<?php
//** BASHANDY **//
require 'composer/vendor/autoload.php';
use Firebase\JWT\JWT;
use GuzzleHttp\Client;

$pushmessage = new pushmessage();

class pushmessage
{
    public function sendMessage($params)
    {
        $rtn = $this->sendMessageAndroidAndIos($params["device_token_id"], $params);
    }

    private static function getAccessToken($credentialsPath)
    {
        $credentials = json_decode(file_get_contents($credentialsPath), true);

        $now_seconds = time();
        $payload = array(
            "iss" => $credentials['client_email'],
            "sub" => $credentials['client_email'],
            "aud" => $credentials['token_uri'],
            "iat" => $now_seconds,
            "exp" => $now_seconds + 3600,
            "scope" => "https://www.googleapis.com/auth/firebase.messaging",
        );
        try {
            $jwt = JWT::encode($payload, $credentials['private_key'], 'RS256'); // استخدم JWT::encode لتوقيع التوكن
            $client = new Client();
            $response = $client->post($credentials['token_uri'], [
                'form_params' => [
                    'grant_type' => 'urn:ietf:params:oauth:grant-type:jwt-bearer',
                    'assertion' => $jwt,
                ],
            ]);

            $data = json_decode($response->getBody(), true);
        } catch (\Exception $e) {
            return false;
        }
        return $data['access_token'];
    }

    public function sendMessageAndroidAndIos($device_token_id, $params)
    {
        $projectId = 'dalil-elsouq';
        $path = 'firebase.json';
        $accessToken = $this->getAccessToken($path);

        $url = "https://fcm.googleapis.com/v1/projects/$projectId/messages:send";
        $notification = [
            'message' => [
                'token' => "$device_token_id",
                'data' => [
                    'push' => 'true',
                    'page_type' => $params['data']['notification_type'],
                    'id' => strval($params['data']['notification_id']),
                    'url' => $params['data']['url'],
                    'sub_url' => $params['data']['sub_url'],
                    'sub_sub_url' => $params['data']['sub_sub_url'],
                    "body" => strip_tags($params['data']['notifiy_message']),
                    "order_id" => strval($params['data']['order_id']),
                    "order_title" => $params['data']['order_title'],
                    "img" => $params['data']['img'],
                    "user_name" => $params['data']['user_name'],
                    "user_type" => $params['data']['user_type'],
                    "receive_user_id" => strval($params['data']['receive_user_id']),
                    "send_user_id" => strval($params['data']['send_user_id']),
                    "date_added" => $params['data']['date_added'],
                    "forceStart" => "1",
                ],
                'notification' => [
                    "title" => strip_tags($params['data']['user_name']),
                    "body" => strip_tags($params['data']['notifiy_message']),
                    "image" => $params['data']['image_url'],
                ],
                'android' => [
                    'notification' => [
                        'sound' => 'default',
                    ]
                ],
                'apns' => [
                    'payload' => [
                        'aps' => [
                            'alert' => [
                        "title" => strip_tags($params['data']['user_name']),
                        "body" => strip_tags($params['data']['notifiy_message']),
                            ],
                            'sound' => 'default',  // الصوت
                            'mutable-content' => 1, // تمكين المحتوى القابل للتغيير لإظهار الصورة
                        ],
                        'fcm_options' => [
                            "image" => $params['data']['image_url'],
                        ]
                    ]
                ]
            ],
        ];
        $headers = [
            'Authorization: Bearer ' . $accessToken,
            'Content-Type: application/json',
        ];
        // echo "<pre>";
        // print_r($notification);
        // echo "</pre>";

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($notification));
        $result = curl_exec($ch);
        $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE); // للحصول على رمز حالة HTTP
        curl_close($ch);
        if ($httpCode !== 200) {
            echo "Error: " . $result;
        }
        return $result;
    }
}
