<?php

$cartObj = new cart();

class cart
{

    public $mDb;
    public $lang;
    public $dateTime;

    public function cart()
    {

        $this->mDb = new iplus();
        $this->lang = LANGUAGE;
        $this->dateTime = date('Y-m-d H:i:s');
    }
    public function checkIFIHaveCart($know, $id, $temp)
    {
        $sql = "SELECT id,facility_id FROM `cart`
                WHERE `user_id` = :id
                AND `status` = 'sending' ";
        $sql .= $know == "0" ? "AND `facility_id` = :facility_id" : "";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $know == "0" ? $stmt->bindParam(':facility_id', $temp['page_id'], PDO::PARAM_INT) : "";
        $stmt->execute();

        if ($stmt->rowCount() > 0) {
            $cart = $stmt->fetch(PDO::FETCH_ASSOC);
            if ($know == 0) {
                return $cart['id'];
            } elseif ($know == 1) {
                return $cart['facility_id'];
            } elseif ($know == 2) {
                return $cart['id'];
            }
        } else {
            return false;
        }
    }

    public function addNewCart($id, $temp)
    {
        $sql = "INSERT INTO `cart`
                SET user_id = :id ,
                status = 'sending' ,
                facility_id = :facility_id ,
                date_added = :date_added";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->bindParam(':facility_id', $temp['page_id'], PDO::PARAM_INT);
        $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);
        $stmt->execute();
        return $this->mDb->connect()->lastInsertId();
    }

    public function Add_TO_Cart($temp, $mo)
    {
        $stmt = "SELECT * FROM `cart_items`
                 WHERE `post_id` = :post_id
                 AND `cart_id` = :cart_id ";
        $stmt = $this->mDb->connect()->prepare($stmt);
        $stmt->bindParam(':post_id', $temp['post_id'], PDO::PARAM_INT);
        $stmt->bindParam(':cart_id', $mo, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        if (!$res) {
            $sql = "INSERT INTO `cart_items`
                    SET 
                        post_id = :post_id ,
                        quantity = :quantity ,
                        cart_id = :cart_id, 
                        date_added = :date_added ";

            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':post_id', $temp['post_id'], PDO::PARAM_INT);
            $stmt->bindParam(':quantity', $temp['quantity'], PDO::PARAM_INT);
            $stmt->bindParam(':cart_id', $mo, PDO::PARAM_INT);
            $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);
            $res = $stmt->execute();

            return $res;
        } else {
            $sql = "UPDATE `cart_items`
            SET quantity = quantity + :quantity , date_added = :date_added
            WHERE `post_id` = :post_id
            AND `cart_id` = :cart_id";

            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':post_id', $temp['post_id'], PDO::PARAM_INT);
            $stmt->bindParam(':quantity', $temp['quantity'], PDO::PARAM_INT);
            $stmt->bindParam(':cart_id', $mo, PDO::PARAM_INT);
            $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);
            $res = $stmt->execute();
            return $res;
        }

    }

    public function Update_Quantity($temp, $mo)
    {

        $sql = "UPDATE `cart_items`
                SET quantity = :quantity
                WHERE `post_id` = :post_id
                AND `cart_id` = :cart_id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':post_id', $temp['post_id'], PDO::PARAM_INT);
        $stmt->bindParam(':quantity', $temp['quantity'], PDO::PARAM_INT);
        $stmt->bindParam(':cart_id', $mo, PDO::PARAM_INT);
        $res = $stmt->execute();
        return $res;
    }
    public function Get_Cart($id)
    {
        $sql = "SELECT p.id, p.product_name, p.price, p.avilability, c.quantity
                FROM `cart_items` c
                JOIN `posts` p ON c.post_id = p.id
                WHERE p.type = 'post' AND c.cart_id = :id";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->execute();
        $cartItems = $stmt->fetchAll(PDO::FETCH_ASSOC);

        $totalQuantity = 0;
        $totalPrice = 0;
        $responseItems = [];

        if ($cartItems) {
            foreach ($cartItems as &$item) {
                $selectSql1 = "SELECT pi.id, pi.name, pi.type, pi.views
                           FROM `post_images` pi
                           WHERE pi.post_id = :postId";

                $selectStmt1 = $this->mDb->connect()->prepare($selectSql1);
                $selectStmt1->bindParam(':postId', $item['id'], PDO::PARAM_INT);
                $selectStmt1->execute();
                $attachments = $selectStmt1->fetch(PDO::FETCH_ASSOC);

                $item['attachment'] = $attachments;

                $totalQuantity += $item['quantity'];
                $totalPrice += $item['price'] * $item['quantity'];

                $responseItems[] = $item;
                $sql5 = "SELECT facility_id FROM `cart` WHERE id = :id";

                $stmt5 = $this->mDb->connect()->prepare($sql5);
                $stmt5->bindParam(':id', $id, PDO::PARAM_INT);
                $stmt5->execute();
                $fac = $stmt5->fetch(PDO::FETCH_ASSOC);

            }
        }

        $response = [
            'items' => $responseItems,
            'total_items' => $totalQuantity,
            'total_price' => $totalPrice,
            'facility_id' => $fac['facility_id'],
        ];

        return $response;
    }

    public function Get_Cart_NUM($id)
    {
        $sql = "SELECT SUM(quantity) AS total_quantity FROM cart_items WHERE cart_id = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->execute();

        $result = $stmt->fetch(PDO::FETCH_ASSOC);
        if ($result['total_quantity'] === null) {
            return 0;
        }
        // Otherwise, return the total quantity
        return (int) $result['total_quantity'];
    }

    public function Delete_From_Cart($temp, $id)
    {
        $sql = "DELETE FROM `cart_items` WHERE `post_id` = :post_id AND `cart_id` = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':post_id', $temp['post_id'], PDO::PARAM_INT);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $res = $stmt->execute();
        $sql = "SELECT C.*
                FROM cart C
                LEFT JOIN cart_items ci ON C.id = ci.cart_id
                GROUP BY C.id
                HAVING COUNT(ci.id) = 0 AND C.status = 'sending'";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->execute();
        $carts = $stmt->fetchAll(PDO::FETCH_ASSOC);
        if (count($carts) > 0) {
            foreach ($carts as $cart) {
                $sql = "UPDATE `cart` SET `status` = 'canceled' WHERE `id` = :id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':id', $cart['id'], PDO::PARAM_INT);
                $stmt->execute();
            }
        }
        return $res;
    }
    public function Delete_Cart($id)
    {
        $sql = "UPDATE `cart` SET `status` = 'canceled' WHERE `id` = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $res = $stmt->execute();
        return $res;
    }
    public function UpdataCartStatus($id)
    {
        $sql = "UPDATE `cart` SET `status` = 'ordered' WHERE `id` = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $res = $stmt->execute();

        return $res;
    }
    public function checkIfPostInMyCart($id, $post_id)
    {
        $sql = "SELECT ci.quantity FROM `cart_items` ci
                LEFT JOIN `cart` c ON c.id = ci.cart_id AND c.status = 'sending'
                WHERE ci.post_id = :post_id AND c.user_id = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->execute();

        if ($stmt->rowCount() > 0) {
            return $stmt->fetch(PDO::FETCH_ASSOC)['quantity'];
        } else {
            return "0";
        }
    }

}