<?php

$devices = new devices();

class devices {

    public $db;
    public $conn;
    public $dateTime;
    public $user;
    public $langCode;
    public function devices() {
        $this->db = new MO();
        $this->conn = $this->db->connect();
        $this->dateTime = date('Y-m-d H:i:s');
        $this->user = USER;
        $this->langCode = LANGUAGE;
    }

    public function checkDeviceToken($aDeciceToken) {
        $sql = "SELECT d.id 
                FROM devices d 
                WHERE d.device_token_id = :device_token
                AND d.user_id = :user_id";
        $stmt = $this->conn->prepare($sql);
        $stmt->bindParam(':device_token', $aDeciceToken);
        $stmt->bindParam(':user_id', $this->user['id']);
        $stmt->execute();
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }
    public function updateDevicesByTokenID($aId, $aLogin = 0) {
        $sql = "UPDATE devices 
                SET login = :login, 
                lang_code = :lang_code 
                WHERE device_token_id = :device_token_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $langCode = LANGUAGE; // تأكد أن LANGUAGE معرفة بشكل آمن
        $stmt->bindValue(':device_token_id', $aId, PDO::PARAM_STR);
        $stmt->bindValue(':login', $aLogin, PDO::PARAM_INT);
        $stmt->bindValue(':lang_code', $langCode, PDO::PARAM_STR);

        $res = $stmt->execute();

        return $res;
    }

    public function checkDevices($aDeviceToken, $aUserId) {
        $sql = "SELECT `id` FROM `devices` WHERE `device_token_id` = :deviceToken AND `user_id` = :userId";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':deviceToken', $aDeviceToken, PDO::PARAM_STR);
        $stmt->bindParam(':userId', $aUserId, PDO::PARAM_INT);
        $stmt->execute();
        return $stmt->fetchColumn();
    }
    public function updateDevicesApi($aId, $aLogin = 0) {
        $sql = "UPDATE `devices` SET `login` = :login , lang_code = '" . LANGUAGE . "'  WHERE `id` = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $aId);
        $stmt->bindParam(':login', $aLogin);
        return $stmt->execute();
    }
    public function addDevicesApi($temp) {
        $sql = "INSERT INTO `devices` (device_token_id, user_id, login,lang_code, date_added) VALUES (:device_token_id, :user_id, :login,'" . LANGUAGE . "', :date_added)";

        $temp['date_added'] = $this->dateTime;
        $stmt = $this->mDb->connect()->prepare($sql);

        $stmt->bindValue(':device_token_id', $temp['device_token_id']);
        $stmt->bindValue(':user_id', $temp['user_id']);
        $stmt->bindValue(':login', $temp['login']);
        $stmt->bindValue(':date_added', $this->dateTime);

        $res = $stmt->execute();

        return $res;
    }
    public function addDeviceToken($temp) {
        $sql = "INSERT INTO device_token 
                    (user_id,device_token, type, date_added ) 
                VALUES 
                    (:user_id, :device_token, :type, :date_added)";
        $stmt = $this->conn->prepare($sql);
        $stmt->bindParam(':device_token_id', $temp['device_token_id'], PDO::PARAM_STR);
        $stmt->bindParam(':type', $temp['type'], PDO::PARAM_STR);
        $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);
        $stmt->bindParam(':user_id', $this->user['id'], PDO::PARAM_INT);
        if ($stmt->execute()) {
            return $this->conn->lastInsertId();
        }
    }

    public function updateDevicesLoginApi($aUserId, $aDeciceToken, $aLogin = 0) {
        if ($aUserId) {
            $sql = "SELECT id FROM device_token WHERE device_token_id = :device_token";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':device_token', $aDeciceToken);
            $stmt->execute();
            $id_token = $stmt->fetchColumn();

            if ($id_token) {
                $sql = "UPDATE devices SET login = :login WHERE `device_token_id` = :id_token";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':login', $aLogin);
                $stmt->bindParam(':id_token', $id_token);
                return $stmt->execute();
            } else {
                $sql = "UPDATE `devices` SET `login` = :login WHERE `user_id` = :user_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':login', $aLogin);
                $stmt->bindParam(':user_id', $aUserId);
                return $stmt->execute();
            }
        }
    }

    public function updateDevicesLangApi($aUserId, $aDeciceToken, $aLangCode) {
        $sql = "UPDATE `devices` SET `lang_code` = :lang_code WHERE `device_token_id` = :device_token_id AND `user_id` = :user_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':lang_code', $aLangCode, PDO::PARAM_STR);
        $stmt->bindParam(':device_token_id', $aDeciceToken, PDO::PARAM_STR);
        $stmt->bindParam(':user_id', $aUserId, PDO::PARAM_INT);
        return $stmt->execute();
    }
}
