<?php

$Lang = new Lang();
class Lang {
    public $db;
    public $conn;
    public $lang;
    public $dateTime;
    public $user;


    public function __construct() {
        $this->db = new MO();
        $this->conn = $this->db->connect();
        $this->lang = LANGUAGE;
        $this->user = CLIENT;
        $this->dateTime = date('Y-m-d H:i:s');
    }
    public function AddNewLang($data) {
        $sql = "INSERT INTO langs 
                SET
                    lang = :lang,
                    name = :name,
                    date_added = :date_added,
                    added_by = :added_by";
        $stmt = $this->conn->prepare($sql);
        $stmt->bindParam(':lang', $data['lang'], PDO::PARAM_STR);
        $stmt->bindParam(':name', $data['name'], PDO::PARAM_STR);
        $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);
        $stmt->bindParam(':added_by', $this->user['id'], PDO::PARAM_STR);
        return $stmt->execute();
    }
    public function checkLang($data) {
        $sql = "SELECT * FROM langs 
                WHERE lang = :lang ";
        $stmt = $this->conn->prepare($sql);
        $stmt->bindParam(':lang', $data['lang'], PDO::PARAM_STR);
        $stmt->execute();
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }
    public function GetLangs($data) {
        $sql = "SELECT name, lang FROM langs WHERE id > 0 ";
        isset($data['name']) && $data['name'] ? $sql .= " AND name LIKE :name" : '';
        $stmt = $this->conn->prepare($sql);
        isset($data['name']) && $data['name'] ? $stmt->bindValue(':name', '%' . $data['name'] . '%', PDO::PARAM_STR) : '';
        $stmt->execute();
        return $stmt->fetchAll(PDO::FETCH_ASSOC);
    }
    public function DeleteLang($id) {
        $sql = "DELETE FROM langs WHERE id = :id ";
        $stmt = $this->conn->prepare($sql);
        $stmt->bindValue(':id', $id, PDO::PARAM_STR);
        return $stmt->execute();
    }
}
