<?php

$notifyObj = new notifications();

class notifications
{

    public $mDb;
    public $userObj;
    public $mConfig;
    public $lang;
    public $dateTime;
    public $pushNotify;

    public function notifications()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->userObj = new users();
        $this->mConfig = $Config;
        $this->pushNotify = new pushmessage();
        $this->lang = LANGUAGE;
        $this->dateTime = date('Y-m-d H:i:s');
    }

    public function getSenderData($id)
    {
        $sql = "SELECT u.user_name, u.img,ua.page_type AS user_type FROM `users` u
                LEFT JOIN `user_auth` ua ON ua.user_id = u.id
                WHERE ua.id = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        return $res;
    }

    public function getPageData($id)
    {
        $sql = "SELECT u.user_name, u.img,ua.page_type AS user_type FROM `user_page_acc` u
                LEFT JOIN `user_auth` ua ON ua.page_id = u.id
                WHERE ua.id = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        return $res;
    }

    public function sendNotificationByType($req, $id, $type)
    {
        if ($req['notificationType'] == 'addOrder') {
            $DOS = $this->getSenderData($id);
            $addNotSend['send_user_id'] = $id;
            $addNotSend['receive_user_id'] = $req['facility_id'];
            $addNotSend['url'] = $req['id'];
            $addNotSend['page_type'] = $req['notificationType'];
            $addNotSend['order_title'] = $req['order_title'];
            $addNotSend['order_id'] = $req['id'];
            $addNotSend['img'] = $DOS['img'];
            $addNotSend['user_name'] = $DOS['user_name'];
            $addNotSend['user_type'] = $DOS['user_type'];
            $addNotSend['image_url'] = "https://api.dalilelsouq.com/uploads/users/" . $DOS['img'];
            $this->sendNewNotification($addNotSend);
        } elseif ($req['notificationType'] == 'addPost') {

            $DOS = $this->getPageData($id);

            $addNotSend['send_user_id'] = $id;
            $addNotSend['url'] = $req['sub_url'];
            $addNotSend['send_user_id'] = $id;
            $addNotSend['page_type'] = $req['notificationType'];
            $addNotSend['img'] = $DOS['img'];
            $addNotSend['user_name'] = $DOS['user_name'];
            $addNotSend['image_url'] = "https://api.dalilelsouq.com/uploads/users/" . $DOS['img'];
            $addNotSend['user_type'] = $DOS['user_type'];

            $followingMe = $this->userObj->getAllFollowingMe($id);
            for ($i = 0; $i < count($followingMe); $i++) {
                $addNotSend['receive_user_id'] = $followingMe[$i]['user_id'];
                $this->sendNewNotification($addNotSend);
            }
        } elseif ($req['notificationType'] == 'likePost' ||
            $req['notificationType'] == 'addComment' ||
            $req['notificationType'] == 'addReplay' ||
            $req['notificationType'] == 'likeComment' ||
            $req['notificationType'] == 'likeReplay' ||
            $req['notificationType'] == 'sharePost'
        ) {

            if ($type == 'page') {
                $DOS = $this->getPageData($id);
            } else {
                $DOS = $this->getSenderData($id);
            }

            $addNotSend['send_user_id'] = $id;
            $addNotSend['receive_user_id'] = $req['owner_node_id'];
            $addNotSend['url'] = $req['post_id'];
            $addNotSend['page_type'] = $req['notificationType'];
            $addNotSend['order_title'] = $req['order_title'];
            $addNotSend['img'] = $DOS['img'];
            $addNotSend['user_name'] = $DOS['user_name'];
            $addNotSend['image_url'] = "https://api.dalilelsouq.com/uploads/users/" . $DOS['img'];
            $addNotSend['user_type'] = $DOS['user_type'];

            $addNotSend['sub_url'] = $req['sub_url'];
            $addNotSend['sub_sub_url'] = $req['sub_sub_url'];

            $this->sendNewNotification($addNotSend);
        } elseif ($req['notificationType'] == 'following') {
            $DOS = $this->getSenderData($id);
            $addNotSend['send_user_id'] = $id ?? "meshrif";
            $addNotSend['receive_user_id'] = $req['follow_user_id'] ?? "meshrif";
            $addNotSend['url'] = $req['id'];
            $addNotSend['page_type'] = $req['notificationType'];
            $addNotSend['order_title'] = $req['order_title'];
            $addNotSend['img'] = $DOS['img'];
            $addNotSend['user_name'] = $DOS['user_name'];
            $addNotSend['image_url'] = "https://api.dalilelsouq.com/uploads/users/" . $DOS['img'];
            $addNotSend['user_type'] = $DOS['user_type'];

            $this->sendNewNotification($addNotSend);
        } elseif ($req['notificationType'] == 'TheOrderIsReceived') {
            if ($type == 'page') {
                $DOS = $this->getPageData($id);
                $addNotSend['image_url'] = "https://api.dalilelsouq.com/uploads/facility/" . $DOS['img'];
            } else {
                $DOS = $this->getSenderData($id);
                $addNotSend['image_url'] = "https://api.dalilelsouq.com/uploads/users/" . $DOS['img'];
            }
            $addNotSend['send_user_id'] = $id;
            $addNotSend['receive_user_id'] = $req['recevier_id'];
            $addNotSend['url'] = $req['id'];
            $addNotSend['page_type'] = $req['notificationType'];
            $addNotSend['order_title'] = $req['order_title'];
            $addNotSend['order_id'] = $req['id'];
            $addNotSend['img'] = $DOS['img'];
            $addNotSend['user_name'] = $DOS['user_name'];
            $addNotSend['user_type'] = $DOS['user_type'];

            $this->sendNewNotification($addNotSend);
        } elseif ($req['notificationType'] == 'TheOrderIsCanceled') {
            if ($type == 'page') {
                $DOS = $this->getPageData($id);
                $addNotSend['image_url'] = "https://api.dalilelsouq.com/uploads/facility/" . $DOS['img'];
            } else {
                $DOS = $this->getSenderData($id);
                $addNotSend['image_url'] = "https://api.dalilelsouq.com/uploads/users/" . $DOS['img'];
            }
            $addNotSend['send_user_id'] = $id;
            $addNotSend['receive_user_id'] = $req['recevier_id'];
            $addNotSend['url'] = $req['id'];
            $addNotSend['page_type'] = $req['notificationType'];
            $addNotSend['order_id'] = $req['id'];
            $addNotSend['order_title'] = $req['order_title'];
            $addNotSend['img'] = $DOS['img'];
            $addNotSend['user_name'] = $DOS['user_name'];
            $addNotSend['image_url'] = "https://api.dalilelsouq.com/uploads/users/" . $DOS['img'];
            $addNotSend['user_type'] = $DOS['user_type'];

            $this->sendNewNotification($addNotSend);
        } elseif ($req['notificationType'] == 'likeFacility') {
            $DOS = $this->getSenderData($id);
            $addNotSend['send_user_id'] = $id ?? "meshrif";
            $addNotSend['receive_user_id'] = $req['facility_id'] ?? "meshrif";
            $addNotSend['url'] = $req['id'];
            $addNotSend['page_type'] = $req['notificationType'];
            $addNotSend['img'] = $DOS['img'];
            $addNotSend['user_name'] = $DOS['user_name'];
            $addNotSend['image_url'] = "https://api.dalilelsouq.com/uploads/users/" . $DOS['img'];
            $addNotSend['user_type'] = $DOS['user_type'];

            $this->sendNewNotification($addNotSend);
        }
    }

    public function sendNewNotification($temp)
    {
        if ($temp['send_user_id'] != $temp['receive_user_id']) {
            $sql = "INSERT INTO `notification` SET ";
            $sql .= "page_type = :page_type,";
            $sql .= "url = :url,";
            $sql .= "sub_url = :sub_url,";
            $sql .= "sub_sub_url = :sub_sub_url,";
            $sql .= "receive_user_id = :receive_user_id,";
            $sql .= "send_user_id = :send_user_id,";
            $sql .= "status = '0',";
            $sql .= "date_added='{$this->dateTime}'";

            $query = $this->mDb->connect()->prepare($sql);

            $query->bindParam(':page_type', $temp['page_type'], PDO::PARAM_STR);
            $query->bindParam(':url', $temp['url'], PDO::PARAM_STR);
            $query->bindParam(':sub_url', $temp['sub_url'], PDO::PARAM_INT);
            $query->bindParam(':sub_sub_url', $temp['sub_sub_url'], PDO::PARAM_INT);
            $query->bindParam(':receive_user_id', $temp['receive_user_id'], PDO::PARAM_STR);
            $query->bindParam(':send_user_id', $temp['send_user_id'], PDO::PARAM_STR);
            $res = $query->execute();
            $id = $this->mDb->connect()->lastInsertId();

            $res2 = $this->getUserDevicesToken($temp['receive_user_id']);
            print_r($res2);
            $messages = $this->makeNotificationMessage($temp, $id);
            // foreach ($messages as $lang_code => $message) {
            //     $this->InsertMessage($message, $id, $lang_code);
            // }

            $unReadMessage = $this->getUnReadNotificationNum($temp['receive_user_id']);

            if ($res2) {

                if ($temp['page_type'] == 'addPost') {

                    foreach ($res2 as $value) {
                        $arr['notification_id'] = $id;
                        $arr['notification_type'] = $temp['page_type'];
                        $arr['url'] = $temp['url'];
                        $arr['order_title'] = $temp['order_title'];
                        $arr['img'] = $temp['img'];
                        $arr['user_name'] = $temp['user_name'];
                        $arr['send_user_id'] = $temp['send_user_id'];
                        $arr['data']['image_url'] = $temp['image_url'];
                        $arr['to'] = $temp['receive_user_id'];
                        $arr['msgcnt'] = $unReadMessage;
                        $arr['notifiy_message'] = $messages[$value['lang_code']];
                        $arr['device_token_id'] = $value['device_token_id'];
                        $arr['platform_type'] = $value['type'];
                        $arr['user_type'] = $temp['user_type'];

                        $this->insert_notification_to_send_cron_job($arr);
                    }
                } else {
                    foreach ($res2 as $value) {
                        $arr['data']['notification_id'] = $id;
                        $arr['data']['notification_type'] = $temp['page_type'];
                        $arr['data']['url'] = $temp['url'];
                        $arr['data']['order_id'] = $temp['order_id'];
                        $arr['data']['order_title'] = $temp['order_title'];
                        $arr['data']['img'] = $temp['img'];
                        $arr['data']['user_name'] = $temp['user_name'];
                        $arr['data']['send_user_id'] = $temp['send_user_id'];
                        $arr['data']['receive_user_id'] = $temp['receive_user_id'];
                        $arr['data']['sub_url'] = $temp['sub_url'];
                        $arr['data']['sub_sub_url'] = $temp['sub_sub_url'];
                        $arr['data']['msgcnt'] = $unReadMessage;
                        $arr['data']['notifiy_message'] = $messages[$value['lang_code']];
                        $arr['data']['image_url'] = $temp['image_url'];
                        $arr['data']['user_type'] = $temp['user_type'];
                        $arr['data']['date_added'] = $this->dateTime;

                        $arr['device_token_id'] = $value['device_token_id'];
                        $arr['platform_type'] = $value['type'];

                        $pushed = $this->pushNotify->sendMessage($arr);
                    }
                }
            }
            return $res;
        }
    }

    public function getUserDevicesToken($aUserId)
    {
        $sql = "SELECT DT.`id` as deviceID, DT.`type`, DT.`device_token_id`, D.`lang_code`
            FROM `devices` D
            LEFT JOIN `device_token` DT ON DT.`id` = D.`device_token_id`
            WHERE D.`user_id` = :user_id
            AND D.`login` = '1'";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $aUserId, PDO::PARAM_INT);
        $stmt->execute();
        return $stmt->fetchAll(PDO::FETCH_ASSOC);
    }

    public function getUnReadNotificationNum($aUserId)
    {
        $sql = "SELECT COUNT(id) FROM `notification` WHERE `receive_user_id` = :receive_user_id AND `status` = '0'";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':receive_user_id', $aUserId, PDO::PARAM_INT);
        $stmt->execute();
        return $stmt->fetchColumn();
    }

    public function getLangForTheApp()
    {
        $sql = "SELECT code FROM `languages` WHERE `id` > '0' ";
        $query = $this->mDb->connect()->prepare($sql);
        $query->execute();
        $result = $query->fetchAll(PDO::FETCH_COLUMN);
        return $result;
    }

    public function makeNotificationMessage($temp, $id)
    {
        $ar = [
            'addOrder' => ' قام باضافة طلب جديد برقم ' . ' ' . $temp['order_id'] . ' من منشأتك ',
            'addPost' => 'قام باضافة منشور جديد',
            'likePost' => 'قام بالاعجاب علي منشورك',
            'addComment' => 'قام بإضافة تعليق على منشور لك',
            'likeComment' => 'قام بالاعجاب علي تعليقك',
            'likeReplay' => 'قام بالاعجاب علي رد لك',
            'addReplay' => 'قام بإضافة رد على تعليقك',
            'following' => 'قام بمتابعة حسابك',
            'sharePost' => 'قام بمشاركة منشور لك',
            'likeFacility' => 'قام بالإعجاب علي صفحتك',
            'TheOrderIsCanceled' => ' قام بإلغاء الطلب رقم ' . $temp['order_id'] . ' الخاص بك ',
            'TheOrderIsReceived' => ' تم استلام الطلب رقم ' . $temp['order_id'],
        ];
        $en = [
            'addOrder' => 'added a new order number ' . $temp['order_id'] . ' from your facility',
            'addPost' => 'added a new post',
            'likePost' => 'liked your post',
            'addComment' => 'added a comment on your post',
            'likeComment' => 'liked your comment',
            'likeReplay' => 'liked your replay',
            'addReplay' => 'added a reply to your comment',
            'following' => 'has followed your account',
            'sharePost' => 'shared your post',
            'likeFacility' => 'liked your page',
            'TheOrderIsCanceled' => 'canceled the order number ' . $temp['order_id'],
            'TheOrderIsReceived' => 'the order has been delivered number' . $temp['order_id'],
        ];

        $langs = $this->getLangForTheApp();
        $messages = [];

        foreach ($langs as $lang) {
            $langCode = $lang;

            if ($langCode == 'ar') {
                $message = $ar[$temp['page_type']];
            } else {
                $message = $en[$temp['page_type']];
            }
            $this->InsertMessage($message, $id, $langCode);
            $messages[$langCode] = $message;
        }

        return $messages;
    }

    public function InsertMessage($message, $notification_id, $lang_code)
    {
        $sql = "INSERT INTO `notification_langs` (message, notification_id, lang_code) VALUES (:message, :notification_id, :lang_code)";
        $query = $this->mDb->connect()->prepare($sql);
        $query->bindParam(':message', $message, PDO::PARAM_STR);
        $query->bindParam(':notification_id', $notification_id, PDO::PARAM_INT);
        $query->bindParam(':lang_code', $lang_code, PDO::PARAM_STR);
        $query->execute();
        return $query->rowCount();
    }

    public function insert_notification_to_send_cron_job($data)
    {
        $sql = "INSERT INTO `notification_to_send_cron_job` SET
            notification_id = :notification_id,
            notification_type = :notification_type,
            url = :url,
            img = :img,
            user_name = :user_name,
            msgcnt = :msgcnt,
            `to` = :to,
            user_id = :user_id,
            notifiy_message = :notifiy_message,
            platform_type = :platform_type,
            device_token_id = :device_token_id,
            date_added = :date_added";

        $query = $this->mDb->connect()->prepare($sql);
        $query->bindParam(':notification_id', $data['notification_id'], PDO::PARAM_INT);
        $query->bindParam(':notification_type', $data['notification_type'], PDO::PARAM_STR);
        $query->bindParam(':url', $data['url'], PDO::PARAM_STR);
        $query->bindParam(':img', $data['img'], PDO::PARAM_STR);
        $query->bindParam(':user_name', $data['user_name'], PDO::PARAM_STR);
        $query->bindParam(':user_id', $data['user_id'], PDO::PARAM_INT);
        $query->bindParam(':msgcnt', $data['msgcnt'], PDO::PARAM_INT);
        $query->bindParam(':to', $data['to'], PDO::PARAM_INT);
        $query->bindParam(':notifiy_message', $data['notifiy_message'], PDO::PARAM_STR);
        $query->bindParam(':platform_type', $data['platform_type'], PDO::PARAM_STR);
        $query->bindParam(':device_token_id', $data['device_token_id'], PDO::PARAM_STR);
        $query->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);

        $query->execute();
        return $this->mDb->connect()->lastInsertId();
    }

    public function updateNotifyStatus($aId)
    {
        $sql = "UPDATE notification SET status = '1' WHERE id = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $aId, PDO::PARAM_INT);
        $stmt->execute();
        return $stmt->rowCount();
    }

    public function getUnReadNotificationNum_New($aUserId)
    {
        $sql = " SELECT count(id)  FROM ` notification`";
        $sql .= " WHERE `receive_user_id` = '{$aUserId}'";
        $sql .= " AND `status` = '0'";
        return $this->mDb->getOne($sql);
    }

    public function getUser_Name($aUserId)
    {

        $sql = "SELECT page_type FROM user_auth WHERE id = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $aUserId, PDO::PARAM_INT);
        $stmt->execute();
        $result = $stmt->fetch(PDO::FETCH_ASSOC);
        if ($result['page_type'] == 'user') {
            $sql = "SELECT u.user_name,u.img,ua.page_type AS user_type FROM users u
                    LEFT JOIN user_auth ua ON ua.user_id = u.id
                    WHERE ua.id = :id AND ua.active = '1'";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':id', $aUserId, PDO::PARAM_INT);
            $stmt->execute();
            $result = $stmt->fetch(PDO::FETCH_ASSOC);

            return $result;
        } else {
            $sql = "SELECT upa.user_name,upa.img,ua.page_type AS user_type FROM user_page_acc upa
                    LEFT JOIN user_auth ua ON ua.page_id = upa.id
                    WHERE ua.id = :id";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':id', $aUserId, PDO::PARAM_INT);
            $stmt->execute();
            $result = $stmt->fetch(PDO::FETCH_ASSOC);
            return $result;
        }
    }

    public function getNotificationsList($aUserId, $aStart = 0, $aLimit = 0, $type)
    {
        $sql = "SELECT DISTINCT N.*, nl.message AS body
                FROM notification N
                LEFT JOIN user_auth U ON U.id = N.receive_user_id
                LEFT JOIN notification_langs nl ON N.id = nl.notification_id AND nl.lang_code = '" . LANGUAGE . "'
                WHERE N.receive_user_id = :user_id
                ORDER BY N.id DESC";
        $sql .= $aLimit ? " LIMIT :start, :limit" : '';

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindValue(':user_id', $aUserId, PDO::PARAM_INT);
        if ($aLimit) {
            $stmt->bindValue(':start', $aStart, PDO::PARAM_INT);
            $stmt->bindValue(':limit', $aLimit, PDO::PARAM_INT);
        }
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);

        // foreach ($res as &$notification) {
        //     $notification['user_name'] = $this->getUser_Name($notification['send_user_id']);
        // }

        for ($i = 0; $i < count($res); $i++) {
            if ($res[$i]['page_type'] == 'admin_notification') {
                $res[$i]['body'] = strip_tags($this->getNotificationAdmin_notificationContent($res[$i]['url']));
                unset($res[$i]['order_title']);
            } else {

                $user_info = $this->getUser_Name($res[$i]['send_user_id']);

                $res[$i]['user_name'] = $user_info['user_name'];
                $res[$i]['user_type'] = $user_info['user_type'];
                $res[$i]['img'] = $user_info['img'];
            }

            if (date_offeset) {
                $res[$i]['last_date_added'] = $res[$i]['date_added'];
                $dt = new DateTime();
                $dt->setTimestamp(strtotime($res[$i]['date_added']));
                $dt->setTimezone(new DateTimeZone(date_offeset));
                $res[$i]['date_added'] = $dt->format('Y-m-d H:i:s');
            }

        }

        return $res;
    }

    public function getNotificationAdmin_notificationContent($admin_notification_id)
    {
        $sql = " SELECT   nl.notification FROM `admin_notification_langs` nl   ";
        $sql .= " WHERE nl.`admin_notification_id`= '{$admin_notification_id}'  AND nl.`lang_code`='" . LANGUAGE . "' ";
//        echo $sql . "<hr>";
        $res = $this->mDb->getOne($sql);
        return $res ? $res : '';
    }

    public function getNotificationDetails($id, $user_id)
    {
        $sql = "SELECT n.id, nl.notification AS body
                FROM notification n
                LEFT JOIN user_auth u ON u.id = n.receive_user_id
                LEFT JOIN admin_notification_langs nl ON nl.admin_notification_id = n.url
                WHERE n.id = :id AND n.receive_user_id = :user_id AND nl.lang_code = '" . LANGUAGE . "'";

        $stmt = $this->mDb->connect()->prepare($sql);

        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);

        $stmt->execute();

        $result = $stmt->fetch(PDO::FETCH_ASSOC);

        return $result;
    }

}
