<?php

$orderObj = new orders();

class orders
{

    public $mDb;
    public $mConfig;
    public $notification;
    public $lang;
    public $dateTime;

    public function orders()
    {
        global $Config;
        $this->notification = new notifications();
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->lang = LANGUAGE;
        $this->dateTime = date('Y-m-d H:i:s');
    }
    //****************************************** Customer ******************************************
    //****************************************** Customer ******************************************
    //****************************************** Customer ******************************************
    //****************************************** Customer ******************************************
    //****************************************** Customer ******************************************

    public function addOrder($temp, $id)
    {
        global $cartObj;
        $mo = $cartObj->checkIFIHaveCart(2, $id, 0);
        $mo1 = $cartObj->checkIFIHaveCart(1, $id, 0);
        $mo2 = $cartObj->Get_Cart($mo);
        if ($mo) {
            $mo_touch = $cartObj->UpdataCartStatus($mo);
            if ($mo_touch) {
                $sql = "INSERT INTO orders SET
                        user_id = :user_id ,
                        facility_id = :facility_id ,
                        cart_id = :cart_id,
                        order_desc = :order_desc,
                        status = 'Processing',
                        date_added = :date_added";

                $stmt = $this->mDb->connect()->prepare($sql);

                $stmt->bindParam(':user_id', $id);
                $stmt->bindParam(':facility_id', $mo1);
                $stmt->bindParam(':cart_id', $mo);
                $stmt->bindParam(':order_desc', $temp['order_desc']);
                $stmt->bindParam(':date_added', $this->dateTime);

                $res = $stmt->execute();
                $last_id = $this->mDb->connect()->lastInsertId();
                if ($res && isset($mo2['items'])) {
                    foreach ($mo2['items'] as $temp2) {
                        $sql = "INSERT INTO order_items SET
                                order_id = :order_id,
                                price = :price,
                                post_id = :post_id,
                                quantity = :quantity,
                                total_price = :total_price";

                        $stmt = $this->mDb->connect()->prepare($sql);

                        $total_price = $temp2['price'] * $temp2['quantity'];

                        $stmt->bindParam(':order_id', $last_id);
                        $stmt->bindParam(':price', $temp2['price']);
                        $stmt->bindParam(':post_id', $temp2['id']);
                        $stmt->bindParam(':quantity', $temp2['quantity']);
                        $stmt->bindParam(':total_price', $total_price);

                        $res = $stmt->execute();

                    }
                    return $last_id;
                }

            } else {

            }

        }

    }
    public function getOrders_ThatIsDelivering($id, $lat, $lon, $start, $limit)
    {
        $sql = "SELECT o.id, o.facility_id, o.status, upa.mobile, upa.user_name,a.lat,a.lon,
                        SUM(oi.quantity) AS total_quantity,
                        SUM(oi.total_price) AS total_price,
                        (6371 * acos(cos(radians(:lat)) * cos(radians(a.lat)) * cos(radians(a.lon) - radians(:lon)) + sin(radians(:lat)) * sin(radians(a.lat)))) AS distance,
                        o.date_added
                FROM orders o
                LEFT JOIN order_items oi ON oi.order_id = o.id
                LEFT JOIN user_auth a ON o.facility_id = a.id
                LEFT JOIN user_page_acc upa ON a.page_id = upa.id
                WHERE o.user_id = :user_id
                AND o.status = 'Processing'
                AND o.deleted = '0'
                GROUP BY o.id
                ORDER BY o.date_added DESC";

        // Add the LIMIT clause using parameters
        $sql .= " LIMIT :start, :limit";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $id);
        $stmt->bindParam(':lat', $lat);
        $stmt->bindParam(':lon', $lon);
        $stmt->bindParam(':start', $start, PDO::PARAM_INT);
        $stmt->bindParam(':limit', $limit, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        $this->getTimeZone($res);
        return $res;
    }

    public function getOrders_ThatIsReceived($id, $lat, $lon, $start, $limit)
    {
        $sql = "SELECT o.id,o.facility_id , o.status,upa.mobile,upa.user_name,a.lat,a.lon,
                        SUM(oi.quantity) AS total_quantity,
                        SUM(oi.total_price) AS total_price,
                        (6371 * acos(cos(radians($lat)) * cos(radians(a.lat)) * cos(radians(a.lon) - radians($lon)) + sin(radians($lat)) * sin(radians(a.lat)))) AS distance,
                        o.date_added
                FROM orders o
                LEFT JOIN order_items oi ON oi.order_id = o.id
                LEFT JOIN user_auth a ON o.facility_id = a.id
                LEFT JOIN user_page_acc upa ON a.page_id = upa.id
                WHERE o.user_id = :user_id
                AND o.status = 'Received'
                AND o.deleted = '0'

                GROUP BY o.id
                ORDER BY o.date_added DESC";
        $sql .= " LIMIT :start, :limit";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $id);
        $stmt->bindParam(':start', $start, PDO::PARAM_INT);
        $stmt->bindParam(':limit', $limit, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        $this->getTimeZone($res);
        return $res;

    }
    public function getOrders_ThatIsCanceled($id, $lat, $lon, $start, $limit)
    {
        $sql = "SELECT o.id,o.facility_id , o.status,upa.mobile,upa.user_name,a.lat,a.lon,
                        SUM(oi.quantity) AS total_quantity,
                        SUM(oi.total_price) AS total_price,
                        (6371 * acos(cos(radians($lat)) * cos(radians(a.lat)) * cos(radians(a.lon) - radians($lon)) + sin(radians($lat)) * sin(radians(a.lat)))) AS distance,
                        o.date_added
                FROM orders o
                LEFT JOIN order_items oi ON oi.order_id = o.id
                LEFT JOIN user_auth a ON o.facility_id = a.id
                LEFT JOIN user_page_acc upa ON a.page_id = upa.id
                WHERE o.user_id = :user_id
                AND o.status = 'Canceled'
                AND o.deleted = '0'
                GROUP BY o.id
                ORDER BY o.date_added DESC";

        $sql .= " LIMIT :start, :limit";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $id);
        $stmt->bindParam(':start', $start, PDO::PARAM_INT);
        $stmt->bindParam(':limit', $limit, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        $this->getTimeZone($res);
        return $res;

    }
    public function Cancel_Order($order_id, $id)
    {
        $sql = "UPDATE `orders` SET `status` = 'Canceled' WHERE `id` = :order_id AND `user_id` = :user_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':order_id', $order_id, PDO::PARAM_INT);
        $stmt->bindParam(':user_id', $id, PDO::PARAM_INT);
        $res = $stmt->execute();
        return $res;
    }
    public function getOrderDetails($order_id, $lat, $lon)
    {
        $response = [];
        $responseItems = [];

        $sql = "SELECT oi.*, p.product_name
            FROM order_items oi
            LEFT JOIN posts p ON oi.post_id = p.id
            WHERE order_id = :order_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':order_id', $order_id, PDO::PARAM_INT);
        $stmt->execute();
        $orders = $stmt->fetchAll(PDO::FETCH_ASSOC);
        $this->getTimeZone($orders);

        if ($orders) {
            foreach ($orders as &$item) {
                $selectSql1 = "SELECT pi.id, pi.name, pi.type, pi.views
                           FROM post_images pi
                           WHERE pi.post_id = :postId";

                $selectStmt1 = $this->mDb->connect()->prepare($selectSql1);
                $selectStmt1->bindParam(':postId', $item['post_id'], PDO::PARAM_INT);
                $selectStmt1->execute();
                $attachments = $selectStmt1->fetch(PDO::FETCH_ASSOC);

                $item['attachment'] = $attachments;
                $responseItems[] = $item;
            }
        }

        $orderDetails = $this->getOrderBYID($order_id, $lat, $lon);
        $orderDetails['items'] = $responseItems;

        $response =
            $orderDetails
        ;
        return $response;
    }

    public function getOrderBYID($order_id, $lat, $lon)
    {
        $sql = "SELECT o.id,o.facility_id , o.status,upa.user_name,upa.mobile,a.lat,a.lon,
                        SUM(oi.quantity) AS total_quantity,
                        SUM(oi.total_price) AS total_price,
                        (6371 * acos(cos(radians($lat)) * cos(radians(a.lat)) * cos(radians(a.lon) - radians($lon)) + sin(radians($lat)) * sin(radians(a.lat)))) AS distance,
                        o.date_added
                FROM orders o
                LEFT JOIN order_items oi ON oi.order_id = o.id
                LEFT JOIN user_auth a ON o.facility_id = a.id
                LEFT JOIN user_page_acc upa ON a.page_id = upa.id
                WHERE o.id = :order_id
                GROUP BY o.id
                ORDER BY o.date_added DESC";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':order_id', $order_id);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        $this->getTimeZone($res);
        return $res;

    }
    public function Reserve_Again($temp, $id)
    {
        $sql = 'SELECT * FROM `orders` WHERE `id` = :temp AND `user_id` = :id';
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':temp', $temp['order_id'], PDO::PARAM_INT);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);

        global $cartObj;
        $temp1['page_id'] = $res['facility_id'];
        $temp1['id'] = $res['id'];

        $posts = $cartObj->Get_Cart($res['cart_id']);
        $fac = $cartObj->checkIFIHaveCart(2, $id, 0);
        if ($fac) {
            $fac1 = $cartObj->checkIFIHaveCart(0, $id, $temp1);
            if ($fac == $fac1) {
                foreach ($posts['items'] as $post) {
                    $post['post_id'] = $post['id'];
                    $cartObj->Add_TO_Cart($post, $fac);
                }
                return true;
            } else {
                return false;
            }
        } else {
            $thenewCart = $cartObj->addNewCart($id, $temp1);
            foreach ($posts['items'] as $post) {
                $post['post_id'] = $post['id'];
                $cartObj->Add_TO_Cart($post, $thenewCart);
            }
            if ($thenewCart) {
                return true;
            }
        }
    }

    //****************************************** ACCS ******************************************
    //****************************************** ACCS ******************************************
    //****************************************** ACCS ******************************************
    //****************************************** ACCS ******************************************
    //****************************************** ACCS ******************************************
    public function getOrders_ThatIsDelivering_ForAccs($id, $lat, $lon, $start, $limit)
    {
        $sql = "SELECT o.id,o.facility_id ,o.user_id , o.status,u.mobile,u.user_name,a.lat,a.lon,
                        SUM(oi.quantity) AS total_quantity,
                        SUM(oi.total_price) AS total_price,
                        (6371 * acos(cos(radians($lat)) * cos(radians(a.lat)) * cos(radians(a.lon) - radians($lon)) + sin(radians($lat)) * sin(radians(a.lat)))) AS distance,
                        o.date_added
                FROM orders o
                LEFT JOIN order_items oi ON oi.order_id = o.id
                LEFT JOIN user_auth a ON o.user_id = a.id
                LEFT JOIN users u ON a.user_id = u.id
                WHERE o.facility_id = :user_id
                AND o.status = 'Processing'
                AND o.deleted = '0'

                GROUP BY o.id
                ORDER BY o.date_added DESC";

        $sql .= " LIMIT :start, :limit";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $id);
        $stmt->bindParam(':start', $start, PDO::PARAM_INT);
        $stmt->bindParam(':limit', $limit, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        $this->getTimeZone($res);
        return $res;

    }
    public function getOrders_ThatIsReceived_ForAccs($id, $lat, $lon, $start, $limit)
    {
        $sql = "SELECT o.id,o.facility_id , o.status,u.mobile,u.user_name,a.lat,a.lon,
                        SUM(oi.quantity) AS total_quantity,
                        SUM(oi.total_price) AS total_price,
                        (6371 * acos(cos(radians($lat)) * cos(radians(a.lat)) * cos(radians(a.lon) - radians($lon)) + sin(radians($lat)) * sin(radians(a.lat)))) AS distance,
                        o.date_added
                FROM orders o
                LEFT JOIN order_items oi ON oi.order_id = o.id
                LEFT JOIN user_auth a ON o.user_id = a.id
                LEFT JOIN users u ON a.user_id = u.id
                WHERE o.facility_id = :user_id
                AND o.status = 'Received'
                AND o.deleted = '0'
                GROUP BY o.id
                ORDER BY o.date_added DESC";

        $sql .= " LIMIT :start, :limit";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $id);
        $stmt->bindParam(':start', $start, PDO::PARAM_INT);
        $stmt->bindParam(':limit', $limit, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        $this->getTimeZone($res);
        return $res;

    }
    public function getOrders_ThatIsCanceled_ForAccs($id, $lat, $lon, $start, $limit)
    {
        $sql = "SELECT o.id,o.facility_id , o.status,u.mobile,u.user_name,a.lat,a.lon,
                        SUM(oi.quantity) AS total_quantity,
                        SUM(oi.total_price) AS total_price,
                        (6371 * acos(cos(radians($lat)) * cos(radians(a.lat)) * cos(radians(a.lon) - radians($lon)) + sin(radians($lat)) * sin(radians(a.lat)))) AS distance,
                        o.date_added
                FROM orders o
                LEFT JOIN order_items oi ON oi.order_id = o.id
                LEFT JOIN user_auth a ON o.user_id = a.id
                LEFT JOIN users u ON a.user_id = u.id
                WHERE o.facility_id = :user_id
                AND o.status = 'Canceled'
                AND o.deleted = '0'
                GROUP BY o.id
                ORDER BY o.date_added DESC";

        $sql .= " LIMIT :start, :limit";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $id);
        $stmt->bindParam(':start', $start, PDO::PARAM_INT);
        $stmt->bindParam(':limit', $limit, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        $this->getTimeZone($res);
        return $res;
    }
    public function Cancel_Order_ForAccs($order_id, $id)
    {
        $sql = "UPDATE `orders` SET `status` = 'Canceled' WHERE `id` = :order_id AND `facility_id` = :user_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':order_id', $order_id, PDO::PARAM_INT);
        $stmt->bindParam(':user_id', $id, PDO::PARAM_INT);
        $res = $stmt->execute();
        return $res;
    }
    public function getOrderDetails_ForAccs($order_id, $lat, $lon)
    {
        $response = [];
        $responseItems = [];

        $sql = "SELECT oi.*, p.product_name
            FROM order_items oi
            LEFT JOIN posts p ON oi.post_id = p.id
            WHERE order_id = :order_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':order_id', $order_id, PDO::PARAM_INT);
        $stmt->execute();
        $orders = $stmt->fetchAll(PDO::FETCH_ASSOC);
        $this->getTimeZone($orders);

        if ($orders) {
            foreach ($orders as &$item) {
                $selectSql1 = "SELECT pi.id, pi.name, pi.type, pi.views
                           FROM post_images pi
                           WHERE pi.post_id = :postId";

                $selectStmt1 = $this->mDb->connect()->prepare($selectSql1);
                $selectStmt1->bindParam(':postId', $item['post_id'], PDO::PARAM_INT);
                $selectStmt1->execute();
                $attachments = $selectStmt1->fetch(PDO::FETCH_ASSOC);

                $item['attachment'] = $attachments;
                $responseItems[] = $item;
            }
        }

        $orderDetails = $this->getOrderBYID_For_ACCS($order_id, $lat, $lon);
        $orderDetails['items'] = $responseItems;

        $response = $orderDetails;
        return $response;
    }

    public function getOrderBYID_For_ACCS($order_id, $lat, $lon)
    {
        $sql = "SELECT o.id,o.user_id , o.status,u.mobile,u.user_name,a.lat,a.lon,
                        SUM(oi.quantity) AS total_quantity,
                        SUM(oi.total_price) AS total_price,
                        (6371 * acos(cos(radians($lat)) * cos(radians(a.lat)) * cos(radians(a.lon) - radians($lon)) + sin(radians($lat)) * sin(radians(a.lat)))) AS distance,
                        o.date_added
                FROM orders o
                LEFT JOIN order_items oi ON oi.order_id = o.id
                LEFT JOIN user_auth a ON o.user_id = a.id
                LEFT JOIN users u ON a.user_id = u.id
                WHERE o.id = :order_id
                GROUP BY o.id
                ORDER BY o.date_added DESC";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':order_id', $order_id);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        $this->getTimeZone($res);
        return $res;
    }

    public function Receive_Done($order_id)
    {

        $sql = "UPDATE `orders` SET `status` = 'Received' WHERE `id` = :order_id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':order_id', $order_id, PDO::PARAM_INT);
        $res = $stmt->execute();
        return $res;
    }
    //****************************************** TimeZone ******************************************
    //****************************************** TimeZone ******************************************
    //****************************************** TimeZone ******************************************
    //****************************************** TimeZone ******************************************
    //****************************************** TimeZone ******************************************
    public function getTimeZone($res)
    {
        if (date_offeset) {
            $res['last_date_added'] = $res['date_added'];
            $dt = new DateTime();
            $dt->setTimestamp(strtotime($res['date_added']));
            $dt->setTimezone(new DateTimeZone(date_offeset));
            $res['date_added'] = $dt->format('Y-m-d H:i:s');
        }
    }
    public function GetOrdersCount($id, $type)
    {
        if ($type == "user") {
            $sql = "SELECT
                        SUM(CASE WHEN o.status = 'Processing' THEN 1 ELSE 0 END) AS processing_count,
                        SUM(CASE WHEN o.status = 'Received' THEN 1 ELSE 0 END) AS received_count,
                        SUM(CASE WHEN o.status = 'Canceled' THEN 1 ELSE 0 END) AS canceled_count
                    FROM
                        orders o
                        LEFT JOIN order_items oi ON oi.order_id = o.id
                        LEFT JOIN user_auth a ON o.facility_id = a.id
                        LEFT JOIN user_page_acc upa ON a.page_id = upa.id
                    WHERE
                        o.user_id = :user_id
                        AND o.deleted = '0'";

            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':user_id', $id);
            $stmt->execute();
            $res = $stmt->fetch(PDO::FETCH_ASSOC);
            return $res;
        } elseif ($type == "page") {
            $sql = "SELECT
                        SUM(CASE WHEN o.status = 'Processing' THEN 1 ELSE 0 END) AS processing_count,
                        SUM(CASE WHEN o.status = 'Received' THEN 1 ELSE 0 END) AS received_count,
                        SUM(CASE WHEN o.status = 'Canceled' THEN 1 ELSE 0 END) AS canceled_count
                    FROM
                        orders o
                        LEFT JOIN order_items oi ON oi.order_id = o.id
                        LEFT JOIN user_auth a ON o.user_id = a.id
                        LEFT JOIN users u ON a.user_id = u.id
                    WHERE
                        o.facility_id = :user_id
                        AND o.deleted = '0'
                        AND o.status IN ('Processing', 'Received', 'Canceled')";

            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':user_id', $id);
            $stmt->execute();
            $res = $stmt->fetch(PDO::FETCH_ASSOC);
            return $res;

        }
    }
}
