<?php

$postObj = new Posts();

class Posts {

    public $mDb;
    public $mConfig;
    public $lang;
    public $dateTime;
    public $userObj;
    public $notifications;

    public function Posts() {
        global $Config;
        $this->notifications = new notifications();
        $this->userObj = new users();
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->lang = LANGUAGE;
        $this->dateTime = date('Y-m-d H:i:s');
    }

    //****************************************** post ******************************************
    //****************************************** post ******************************************
    //****************************************** post ******************************************
    //****************************************** post ******************************************
    //****************************************** post ******************************************

    public function checknumofposts($user_id, $post_type) {
        $sql = "SELECT COUNT(id) AS count FROM `posts` WHERE user_id = :user_id AND type = :post_type";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->bindParam(':post_type', $post_type, PDO::PARAM_STR);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        if ($res['count'] == 1) {
            return 'full';
        }
    }

    public function addPost($user_id, $page_id, $temp) {
        $sql = "INSERT INTO `posts`
        SET
        user_id = :user_id,
        type = 'post',
        page_acc_id = :page_id,
        product_name = :product_name,
        description = :description,
        price = :price,
        avilability = :avilability,
        app_version = '" . APP_VERSION . "',
        date_added = :date_added,
        pin = :date_added";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->bindParam(':page_id', $page_id, PDO::PARAM_INT);
        $stmt->bindParam(':product_name', $temp['product_name'], PDO::PARAM_STR);
        $stmt->bindParam(':description', $temp['description'], PDO::PARAM_STR);
        $stmt->bindParam(':price', $temp['price'], PDO::PARAM_STR);
        $stmt->bindParam(':avilability', $temp['avilability'], PDO::PARAM_STR);
        $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);
        $stmt->execute();
        if ($stmt->rowCount() > 0) {
            $postId = $this->mDb->connect()->lastInsertId();

            if (!empty($temp['attachment']) && is_array($temp['attachment'])) {
                foreach ($temp['attachment'] as $image) {
                    $imageSql = "INSERT INTO `post_images` (post_id, name, type) VALUES (:post_id, :image_url, :type)";
                    $imageStmt = $this->mDb->connect()->prepare($imageSql);
                    $imageStmt->bindParam(':post_id', $postId, PDO::PARAM_INT);
                    $imageStmt->bindParam(':image_url', $image['name'], PDO::PARAM_STR);
                    $imageStmt->bindParam(':type', $image['type'], PDO::PARAM_STR);
                    $imageStmt->execute();
                }
            }

            $selectSql = "SELECT p.*
                      FROM `posts` p
                      WHERE p.id = :postId
                      GROUP BY p.id";

            $selectStmt = $this->mDb->connect()->prepare($selectSql);
            $selectStmt->bindParam(':postId', $postId, PDO::PARAM_INT);
            $selectStmt->execute();
            $res1 = $selectStmt->fetch(PDO::FETCH_ASSOC);

            if ($res1) {
                $selectSql1 = "SELECT pi.id, pi.name, pi.type,pi.views
                          FROM `post_images` pi
                          WHERE pi.post_id = :postId";

                $selectStmt1 = $this->mDb->connect()->prepare($selectSql1);
                $selectStmt1->bindParam(':postId', $postId, PDO::PARAM_INT);
                $selectStmt1->execute();
                $res1['attachment'] = $selectStmt1->fetchAll(PDO::FETCH_ASSOC);

                return $res1;
            }
        }

        return false; // If no rows were inserted
    }

    public function updatepostinfree($user_id, $post_id) {
        $sql = "UPDATE `posts` SET `post_free` = '1'
                WHERE `id` = :post_id
                AND `page_acc_id` = :user_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
        $stmt->execute();
    }

    public function addImage($user_id, $page_id, $temp) {
        $sql = "INSERT INTO `posts`
        SET
        user_id = :user_id,
        page_acc_id = :page_id,
        description = :description,
        type = 'image',
        app_version = '" . APP_VERSION . "',
        date_added = :date_added";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->bindParam(':page_id', $page_id, PDO::PARAM_INT);
        $stmt->bindParam(':description', $temp['description'], PDO::PARAM_STR);
        $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);

        $stmt->execute();

        if ($stmt->rowCount() > 0) {
            // Get the ID of the last inserted image post
            $postId = $this->mDb->connect()->lastInsertId();

            // Insert each image URL into the database
            if (!empty($temp['attachment']) && is_array($temp['attachment'])) {
                foreach ($temp['attachment'] as $image) { // Iterate over the attachment array
                    $imageSql = "INSERT INTO `post_images` (post_id, name, type) VALUES (:post_id, :image_url, :type)";
                    $imageStmt = $this->mDb->connect()->prepare($imageSql);
                    $imageStmt->bindParam(':post_id', $postId, PDO::PARAM_INT);
                    $imageStmt->bindParam(':image_url', $image['name'], PDO::PARAM_STR); // Use 'name' for image_url
                    $imageStmt->bindParam(':type', $image['type'], PDO::PARAM_STR); // Use 'type' for type
                    $imageStmt->execute();
                }
            }

            // Query to fetch the details of the added image post
            $selectSql = "SELECT p.*
                      FROM `posts` p
                      WHERE p.id = :postId
                      GROUP BY p.id";

            $selectStmt = $this->mDb->connect()->prepare($selectSql);
            $selectStmt->bindParam(':postId', $postId, PDO::PARAM_INT);
            $selectStmt->execute();
            $res1 = $selectStmt->fetch(PDO::FETCH_ASSOC);

            if ($res1) {
                $selectSql1 = "SELECT pi.id, pi.name, pi.type,pi.views
                          FROM `post_images` pi
                          WHERE pi.post_id = :postId";

                $selectStmt1 = $this->mDb->connect()->prepare($selectSql1);
                $selectStmt1->bindParam(':postId', $postId, PDO::PARAM_INT);
                $selectStmt1->execute();
                $res1['attachment'] = $selectStmt1->fetchAll(PDO::FETCH_ASSOC);

                return $res1;
            }
        }
    }

    public function addVideo($user_id, $page_id, $temp) {
        $postSql = "INSERT INTO `posts`
        SET
        user_id = :user_id,
        page_acc_id = :page_id,
        description = :description,
        type = 'video',
        app_version = '" . APP_VERSION . "',
        date_added = :date_added";

        $postStmt = $this->mDb->connect()->prepare($postSql);
        $postStmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $postStmt->bindParam(':page_id', $page_id, PDO::PARAM_INT);
        $postStmt->bindParam(':description', $temp['description'], PDO::PARAM_STR);
        $postStmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);
        $postStmt->execute();

        if ($postStmt->rowCount() > 0) {
            $postId = $this->mDb->connect()->lastInsertId();

            if (!empty($temp['attachment']) && is_array($temp['attachment'])) {
                foreach ($temp['attachment'] as $image) {
                    $imageSql = "INSERT INTO `post_images` (post_id, name, type) VALUES (:post_id, :image_url, :type)";
                    $imageStmt = $this->mDb->connect()->prepare($imageSql);
                    $imageStmt->bindParam(':post_id', $postId, PDO::PARAM_INT);
                    $imageStmt->bindParam(':image_url', $image['name'], PDO::PARAM_STR);
                    $imageStmt->bindParam(':type', $image['type'], PDO::PARAM_STR);
                    $imageStmt->execute();
                }
            }

            $selectSql = "SELECT p.*
                          FROM `posts` p
                          WHERE p.id = :postId
                          GROUP BY p.id";

            $selectStmt = $this->mDb->connect()->prepare($selectSql);
            $selectStmt->bindParam(':postId', $postId, PDO::PARAM_INT);
            $selectStmt->execute();
            $res1 = $selectStmt->fetch(PDO::FETCH_ASSOC);

            if ($res1) {
                $selectSql1 = "SELECT pi.id, pi.name, pi.type,pi.views
                           FROM `post_images` pi
                           WHERE pi.post_id = :postId";

                $selectStmt1 = $this->mDb->connect()->prepare($selectSql1);
                $selectStmt1->bindParam(':postId', $postId, PDO::PARAM_INT);
                $selectStmt1->execute();

                $res1['attachment'] = $selectStmt1->fetchAll(PDO::FETCH_ASSOC);

                return $res1;
            }
        }

        return false;
    }

    public function increaseVideoViews($video_id) {
        $sql = "UPDATE `post_images` SET `views` = `views` + 1 WHERE `post_id` = :video_id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':video_id', $video_id, PDO::PARAM_INT);
        $stmt->execute();
        return $stmt->rowCount();
    }

    public function editPost($page_id, $temp) {
        $sql = "UPDATE `posts` SET ";
        $sql .= "product_name = :product_name, ";
        $sql .= "description = :description, ";
        $sql .= "price = :price, ";
        $sql .= "avilability = :avilability, ";
        $sql .= "app_version = '" . APP_VERSION . "' ";
        $sql .= "WHERE `id` = :post_id AND page_acc_id = :page_id AND type = 'post'";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':product_name', $temp['product_name']);
        $stmt->bindParam(':description', $temp['description']);
        $stmt->bindParam(':price', $temp['price']);
        $stmt->bindParam(':avilability', $temp['avilability']);
        $stmt->bindParam(':post_id', $temp['post_id'], PDO::PARAM_INT);
        $stmt->bindParam(':page_id', $page_id, PDO::PARAM_INT);

        $res = $stmt->execute();

        if (!empty($temp['last_attachment'])) {
            foreach ($temp['last_attachment'] as $filename) {
                $sql = "DELETE FROM `post_images` WHERE `post_id` = :post_id AND name = :filename";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $temp['post_id'], PDO::PARAM_INT);
                $stmt->bindParam(':filename', $filename, PDO::PARAM_STR);
                $stmt->execute();

                $old_img = "../uploads/posts/" . $filename;
                if (file_exists($old_img)) {
                    if (@unlink($old_img)) {
                        $Data['success'][] = $filename;
                    } else {
                        $Data['error'][] = $filename;
                    }
                }
            }
        }

        if (!empty($temp['attachment']) && is_array($temp['attachment'])) {
            foreach ($temp['attachment'] as $image) {
                $imageSql = "INSERT INTO `post_images` (post_id, name, type) VALUES (:post_id, :image_url, :type)";
                $imageStmt = $this->mDb->connect()->prepare($imageSql);
                $imageStmt->bindParam(':post_id', $temp['post_id'], PDO::PARAM_INT);
                $imageStmt->bindParam(':image_url', $image['name'], PDO::PARAM_STR);
                $imageStmt->bindParam(':type', $image['type'], PDO::PARAM_STR);
                $imageStmt->execute();
            }
        }

        return $res;
    }

    public function edit_video($page_id, $temp) {
        $sql = "UPDATE `posts` SET ";
        $sql .= "description = :description, ";
        $sql .= "app_version = '" . APP_VERSION . "' ";
        $sql .= "WHERE `id` = :post_id AND page_acc_id = :page_id";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':description', $temp['description']);
        $stmt->bindParam(':post_id', $temp['post_id'], PDO::PARAM_INT);
        $stmt->bindParam(':page_id', $page_id, PDO::PARAM_INT);

        $res = $stmt->execute();

        if (!empty($temp['last_attachment'])) {
            foreach ($temp['last_attachment'] as $filename) {
                $sql = "DELETE FROM `post_images` WHERE `post_id` = :post_id AND name = :filename";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $temp['post_id'], PDO::PARAM_INT);
                $stmt->bindParam(':filename', $filename, PDO::PARAM_STR);
                $stmt->execute();

                $old_img = "../uploads/posts/" . $filename;
                if (file_exists($old_img)) {
                    if (@unlink($old_img)) {
                        $Data['success'][] = $filename;
                    } else {
                        $Data['error'][] = $filename;
                    }
                }
            }
        }

        if (!empty($temp['attachment']) && is_array($temp['attachment'])) {
            foreach ($temp['attachment'] as $image) {
                $imageSql = "INSERT INTO `post_images` (post_id, name, type) VALUES (:post_id, :image_url, :type)";
                $imageStmt = $this->mDb->connect()->prepare($imageSql);
                $imageStmt->bindParam(':post_id', $temp['post_id'], PDO::PARAM_INT);
                $imageStmt->bindParam(':image_url', $image['name'], PDO::PARAM_STR);
                $imageStmt->bindParam(':type', $image['type'], PDO::PARAM_STR);
                $imageStmt->execute();
            }
        }

        return $res;
    }

    public function edit_image($page_id, $temp) {
        $sql = "UPDATE `posts` SET ";
        $sql .= "description = :description, ";
        $sql .= "app_version = '" . APP_VERSION . "' ";
        $sql .= "WHERE `id` = :post_id AND page_acc_id = :page_id";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':description', $temp['description']);
        $stmt->bindParam(':post_id', $temp['post_id'], PDO::PARAM_INT);
        $stmt->bindParam(':page_id', $page_id, PDO::PARAM_INT);

        $res = $stmt->execute();

        if (!empty($temp['last_attachment'])) {
            foreach ($temp['last_attachment'] as $filename) {
                $sql = "DELETE FROM `post_images` WHERE `post_id` = :post_id AND name = :filename";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $temp['post_id'], PDO::PARAM_INT);
                $stmt->bindParam(':filename', $filename, PDO::PARAM_STR);
                $stmt->execute();
                $old_img = "../uploads/posts/" . $filename;
                if (file_exists($old_img)) {
                    if (@unlink($old_img)) {
                        $Data['success'][] = $filename;
                    } else {
                        $Data['error'][] = $filename;
                    }
                }
            }
        }

        if (!empty($temp['attachment']) && is_array($temp['attachment'])) {
            foreach ($temp['attachment'] as $image) {
                $imageSql = "INSERT INTO `post_images` (post_id, name, type) VALUES (:post_id, :image_url, :type)";
                $imageStmt = $this->mDb->connect()->prepare($imageSql);
                $imageStmt->bindParam(':post_id', $temp['post_id'], PDO::PARAM_INT);
                $imageStmt->bindParam(':image_url', $image['name'], PDO::PARAM_STR);
                $imageStmt->bindParam(':type', $image['type'], PDO::PARAM_STR);
                $imageStmt->execute();
            }
        }

        return $res;
    }

    public function checkIFPostISMyPost($post_id, $u_id) {
        $sql = "SELECT id FROM posts WHERE id = :post_id AND page_acc_id = :u_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
        $stmt->bindParam(':u_id', $u_id, PDO::PARAM_INT);
        $stmt->execute();
        return $stmt->fetchColumn();
    }

    public function deletePost($post_id, $u_id) {
        $id = $this->checkIFPostISMyPost($post_id, $u_id);
        if ($id) {
            $sql = "SELECT `post_free`,`type` FROM `posts` WHERE id = :id";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':id', $post_id, PDO::PARAM_INT);
            $stmt->execute();
            $post_free = $stmt->fetch(PDO::FETCH_ASSOC);
            if ($post_free['post_free'] == '1') {
                $sql = "UPDATE  `posts` SET `post_free` = '0' , pined = '0'  WHERE `id` = :post_id AND `page_acc_id` = :user_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
                $stmt->bindParam(':user_id', $u_id, PDO::PARAM_INT);
                $res = $stmt->execute();
                if ($post_free['type'] == 'image') {
                    $post_free['type'] = 'img';
                }

                $sql = "UPDATE  `post_free` SET `{$post_free['type']}` = '0'  WHERE  `user_id` = :user_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':user_id', $u_id, PDO::PARAM_INT);
                $res = $stmt->execute();
            }
            if ($post_free['type'] == 'image' || $post_free['type'] == 'video') {

                $sql = "SELECT id FROM `post_comments` WHERE post_id = :post_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
                $stmt->execute();

                $ids = $stmt->fetchAll(PDO::FETCH_ASSOC);
                foreach ($ids as $comment) {
                    $sql = "DELETE FROM `statistics` WHERE the_id = :comment";
                    $stmt = $this->mDb->connect()->prepare($sql);
                    $stmt->bindParam(':comment', $comment, PDO::PARAM_STR);
                    $stmt->execute();
                }

                $sql = "DELETE FROM `statistics` WHERE the_id = :post_id AND is_on = :type";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
                $stmt->bindParam(':type', $post_free['type'], PDO::PARAM_STR);
                $stmt->execute();

                $sql = "SELECT img FROM `post_comments` WHERE post_id = :post_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
                $stmt->execute();

                $images = $stmt->fetchAll(PDO::FETCH_ASSOC);
                foreach ($images as $image) {
                    $old_img = "../uploads/posts/" . $image['name'];
                    if (file_exists($old_img)) {
                        if (@unlink($old_img)) {
                            $Data['success'][] = $image['name'];
                        } else {
                            $Data['error'][] = $image['name'];
                        }
                    }
                }

                $sql = "DELETE FROM `post_comments` WHERE post_id = :post_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
                $stmt->execute();

                $sql = "SELECT name FROM `post_images` WHERE post_id = :post_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
                $stmt->execute();

                $images = $stmt->fetchAll(PDO::FETCH_ASSOC);
                foreach ($images as $image) {
                    $old_img = "../uploads/posts/" . $image['name'];
                    if (file_exists($old_img)) {
                        if (@unlink($old_img)) {
                            $Data['success'][] = $image['name'];
                        } else {
                            $Data['error'][] = $image['name'];
                        }
                    }
                }
                $sql = "DELETE FROM `post_images` WHERE post_id = :post_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
                $stmt->execute();

                $sql = "DELETE FROM `posts` WHERE id = :post_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
                $res = $stmt->execute();

                return $res;
            } else {
                $sql = "UPDATE  `posts` SET `is_deleted` = '1' , pined = '0'  WHERE `id` = :post_id AND `page_acc_id` = :user_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
                $stmt->bindParam(':user_id', $u_id, PDO::PARAM_INT);
                $res = $stmt->execute();
                return $res;
            }
        } else {
            return false;
        }
    }

    public function getProfilePosts($user_id, $profile_id, $aStart = 0, $aLimit = 0, $product_name) {
        $sql = "SELECT
                    P.*,
                    U.user_name,
                    U.img ";
        $sql .= "FROM posts P ";
        $sql .= "LEFT JOIN user_auth UA ON UA.id = P.page_acc_id ";
        $sql .= "LEFT JOIN user_page_acc U ON UA.page_id = U.id "; // Assuming UA.page_id is the page_acc_id
        $sql .= "WHERE P.page_acc_id = :profile_id AND P.is_deleted = '0' AND UA.active = '1'  ";
        $sql .= $product_name ? " AND (P.product_name LIKE :product_name OR P.description LIKE :product_name)" : "";

        $sql .= " ORDER BY ";
        $sql .= "CASE
                    WHEN P.pined = '1' THEN P.pin
                END DESC,
                CASE
                    WHEN P.pined = '0' THEN P.id
                END DESC,
                P.id DESC"; // Secondary sorting by date_added for non-pinned posts

        $sql .= " LIMIT :start, :limit";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':profile_id', $profile_id, PDO::PARAM_INT);
        if ($product_name) {
            $productNameParam = "%$product_name%";
            $stmt->bindParam(':product_name', $productNameParam, PDO::PARAM_STR);
        }
        $stmt->bindParam(':start', $aStart, PDO::PARAM_INT);
        $stmt->bindParam(':limit', $aLimit, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);

        global $cartObj;
        if ($res) {
            foreach ($res as &$post) {
                $post['likePost'] = $this->checkPostOrCommentOrReplayByUser_idAndType($post['id'], $user_id, 'like', $post['type']);
                if ($post['type'] == 'post') {
                    $post['is_in_cart'] = $cartObj->checkIfPostInMyCart($user_id, $post['id']);
                }

                $post['statistics'] = $this->getNodesStatisticsById($post['id'], $post['type']);
                // $post['comments'] = $this->getcommentsByPostId($user_id, $post['id'], 0, 10, 'comment');
                $post['description'] = str_replace('<br />', ' <br> ', str_replace(PHP_EOL, '', nl2br($post['description'])));
                // $post['ser_name'] = '';
                // $post['ser_image'] = '';
                // $post['ser_description'] = '';

                $post['attachment'] = $this->getAttachments($post['id']);
                if (date_offeset) {
                    $dt = new DateTime();
                    $dt->setTimestamp(strtotime($post['date_added']));
                    $dt->setTimezone(new DateTimeZone(date_offeset));
                    $post['date_added'] = $dt->format('Y-m-d H:i:s');
                }
            }
        }

        return $res;
    }

    public function getAttachments($post_id) {
        $selectSql1 = "SELECT pi.id, pi.name, pi.type,pi.views
                           FROM `post_images` pi
                           WHERE pi.post_id = :postId";

        $selectStmt1 = $this->mDb->connect()->prepare($selectSql1);
        $selectStmt1->bindParam(':postId', $post_id, PDO::PARAM_INT);
        $selectStmt1->execute();
        $res = $selectStmt1->fetchAll(PDO::FETCH_ASSOC);

        return $res;
    }

    public function getPostDetails($post_id, $user_id = 0, $comment_id = '') {
        $sql = "SELECT P.*, upa.img, upa.user_name, upa.mobile
            FROM `posts` P
            LEFT JOIN user_auth ua ON ua.id = P.page_acc_id
            LEFT JOIN user_page_acc upa ON upa.id = ua.page_id
            WHERE P.id = :post_id";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);

        if ($res) {
            global $cartObj;
            if ($res['type'] == 'post') {
                $res['is_in_cart'] = $cartObj->checkIfPostInMyCart($user_id, $res['id']);
            }
            $res['likePost'] = $this->checkPostOrCommentOrReplayByUser_idAndType($post_id, $user_id, 'like', $res['type']);
            $res['statistics'] = $this->getNodesStatisticsById($post_id, $res['type']);
            $res['comments'] = $this->getcommentsByPostId($user_id, $post_id, 0, 10, 'comment', $comment_id);
            $res['attachment'] = $this->getAttachments($post_id);

            $res['description'] = str_replace('<br />', ' <br> ', str_replace(PHP_EOL, '', nl2br($res['description'])));
            if (date_offeset) {
                $dt = new DateTime();
                $dt->setTimestamp(strtotime($res['date_added']));
                $dt->setTimezone(new DateTimeZone(date_offeset));
                $res['date_added'] = $dt->format('Y-m-d H:i:s');
            }

            return $res;
        }
    }

    public function getNearbyPosts($user_id, $aStart = 0, $aLimit = 0, $product_name, $alat = '0', $alon = '0') {
        $userLat = $alat;
        $userLon = $alon;

        $sql = "SELECT
            P.*,
            U.user_name,
            U.img,
            UA.lat,
            UA.lon";

        if ($userLat !== null && $userLon !== null) {
            $sql .= ", (6371 * acos(cos(radians($userLat)) * cos(radians(UA.lat)) * cos(radians(UA.lon) - radians($userLon)) + sin(radians($userLat)) * sin(radians(UA.lat)))) AS distance";
        }

        $sql .= " FROM
            posts P ";

        $sql .= " LEFT JOIN
                user_auth UA ON UA.id = P.page_acc_id
            LEFT JOIN
                user_page_acc U ON U.id = UA.page_id ";
        $sql .= "WHERE U.id != 0 ";
        $sql .= "AND (P.product_name LIKE '%$product_name%' OR P.description LIKE '%$product_name%') ";
        $sql .= "AND P.is_deleted = '0' AND UA.is_deleted = '0' AND UA.active = '1' AND P.type ='post' ";
        $sql .= 'ORDER BY ' . (($userLat !== null && $userLon !== null) ? 'distance ASC' : 'P.id DESC ');
        $sql .= ", P.date_added DESC "; // Removing the sorting condition related to "pined"
        $sql .= "LIMIT $aStart, $aLimit";

        $res = $this->mDb->getAll($sql);
        if ($res) {
            foreach ($res as &$post) {
                $post['likePost'] = $this->checkPostOrCommentOrReplayByUser_idAndType($post['id'], $user_id, 'like', $post['type']);
                $post['statistics'] = $this->getNodesStatisticsById($post['id'], $post['type']);
                // $post['comments'] = $this->getcommentsByPostId($user_id, $post['id'], 0, 10, 'comment');
                $post['attachment'] = $this->getAttachments($post['id']);
                $post['description'] = str_replace('<br />', ' <br> ', str_replace(PHP_EOL, '', nl2br($post['description'])));
                // $post['post_address'] = '';
                // $post['ser_name'] = '';
                // $post['ser_image'] = '';
                // $post['ser_description'] = ''

                if ($post['service_id'] != '0' && $post['service_id'] != null) {
                    $post['post_address'] = $this->removeSomeData($post['post_address']);
                    $serv = $this->getServiceNameAndImageById($post['service_id']);
                    $post['ser_name'] = $serv['ser_name'];
                    $post['ser_description'] = $serv['ser_description'];
                    $post['ser_image'] = $serv['ser_image'];
                }
            }
        }

        return $res;
    }

    public function update_post_status($id, $type) {
        if ($type == 'post') {
            $sql = "UPDATE post_free SET post = '1' WHERE user_id = :id";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute();
        } elseif ($type == 'video') {
            $sql = "UPDATE post_free SET video = '1' WHERE user_id = :id";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute();
        } elseif ($type == 'image') {
            $sql = "UPDATE post_free SET img = '1' WHERE user_id = :id";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute();
        }
    }

    //****************************************** PIN ******************************************
    //****************************************** PIN ******************************************
    //****************************************** PIN ******************************************
    //****************************************** PIN ******************************************
    //****************************************** PIN ******************************************
    public function checkPinPost($post_id, $user_id) {
        $sql = "SELECT pined FROM posts WHERE id = :post_id AND `page_acc_id` = :user_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->execute();

        return $stmt->fetchColumn();
    }

    public function pin_Post($post_id, $user_id) {
        // First, select the type of the post
        $typeQuery = "SELECT type FROM posts WHERE id = :post_id AND `page_acc_id` = :user_id";
        $typeStmt = $this->mDb->connect()->prepare($typeQuery);
        $typeStmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
        $typeStmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $typeStmt->execute();

        $postType = $typeStmt->fetchColumn();

        // Check if the post type is 'video'
        if ($postType === 'video') {
            $checkVideoQuery = "SELECT id FROM posts WHERE type = 'video' AND pined = 1 AND `page_acc_id`= :user_id";
            $checkVideoStmt = $this->mDb->connect()->prepare($checkVideoQuery);
            $checkVideoStmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
            $checkVideoStmt->execute();

            $existingVideo = $checkVideoStmt->fetchColumn();

            if (!$existingVideo) {
                // If no video is pinned, update the current post to be pinned
                $pinQuery = "UPDATE posts SET pined = 1, pin = :pin WHERE id = :post_id AND `page_acc_id` = :user_id";
                $pinStmt = $this->mDb->connect()->prepare($pinQuery);
                $pinStmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
                $pinStmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
                $pinStmt->bindParam(':pin',$this->dateTime, PDO::PARAM_STR);
                $pinStmt->execute();
                return $pinStmt->rowCount(); // Return the number of affected rows
            }
        } elseif ($postType === 'image') {
            $checkImageQuery = "SELECT id FROM posts WHERE type = 'image' AND pined = 1 AND `page_acc_id` = :user_id";
            $checkImageStmt = $this->mDb->connect()->prepare($checkImageQuery);
            $checkImageStmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
            $checkImageStmt->execute();
            $existingImage = $checkImageStmt->fetchColumn();

            if (!$existingImage) {
                // If no image is pinned, update the current post to be pinned
                $pinQuery = "UPDATE posts SET pined = 1, pin = :pin WHERE id = :post_id AND `page_acc_id` = :user_id";
                $pinStmt = $this->mDb->connect()->prepare($pinQuery);
                $pinStmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
                $pinStmt->bindParam(':pin',$this->dateTime, PDO::PARAM_STR);
                $pinStmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
                $pinStmt->execute();
                return $pinStmt->rowCount(); // Return the number of affected rows
            }
        } elseif ($postType === 'post') {
            $checkPostQuery = "SELECT id FROM posts WHERE type = 'post' AND pined = 1 AND `page_acc_id` = :user_id";
            $checkPostStmt = $this->mDb->connect()->prepare($checkPostQuery);
            $checkPostStmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
            $checkPostStmt->execute();

            $existingPost = $checkPostStmt->fetchColumn();

            if (!$existingPost) {
                // If no post is pinned, update the current post to be pinned
                $pinQuery = "UPDATE posts SET pined = 1, pin = :pin WHERE id = :post_id AND `page_acc_id` = :user_id";
                $pinStmt = $this->mDb->connect()->prepare($pinQuery);
                $pinStmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
                $pinStmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
                $pinStmt->bindParam(':pin',$this->dateTime, PDO::PARAM_STR);
                $pinStmt->execute();
                return $pinStmt->rowCount(); // Return the number of affected rows
            }
        }

        // Return 0 if no action was taken
        return 0;
    }

    public function unpin_Post($post_id, $user_id) {
        $deletePin = "UPDATE posts SET pined = 0  WHERE  pined = 1 AND `page_acc_id` = :user_id AND id = :post_id";
        $checkPinStmt = $this->mDb->connect()->prepare($deletePin);
        $checkPinStmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
        $checkPinStmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $checkPinStmt->execute();
        return $checkPinStmt->rowCount();
    }

    //****************************************** likes ******************************************
    //****************************************** likes ******************************************
    //****************************************** likes ******************************************
    //****************************************** likes ******************************************
    //****************************************** likes ******************************************
    public function checkPostOrCommentOrReplayByUser_idAndType($id, $user_id, $type, $is_on) {
        $sql = "SELECT id FROM statistics WHERE the_id = :id AND user_id = :user_id AND type = :type AND is_on = :is_on";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->bindParam(':type', $type, PDO::PARAM_STR);
        $stmt->bindParam(':is_on', $is_on, PDO::PARAM_STR);

        $stmt->execute();

        return $stmt->fetchColumn() ? true : false;
    }

    public function addlike($id, $user_id, $type, $is_on) {
        $sql = "INSERT INTO statistics (the_id, user_id, type, is_on, app_version, date_added) VALUES (:the_id, :user_id, :type, :is_on, '" . APP_VERSION . "', :date_added)";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':the_id', $id, PDO::PARAM_INT);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->bindParam(':type', $type, PDO::PARAM_STR);
        $stmt->bindParam(':is_on', $is_on, PDO::PARAM_STR);
        $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);
        return $stmt->execute();
    }

    public function deletelike($id, $user_id, $type, $is_on) {
        $sql = "DELETE FROM statistics WHERE the_id = :the_id AND user_id = :user_id AND type = :type AND is_on = :is_on";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':the_id', $id, PDO::PARAM_INT);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->bindParam(':type', $type, PDO::PARAM_STR);
        $stmt->bindParam(':is_on', $is_on, PDO::PARAM_STR);

        return $stmt->execute();
    }

    //****************************************** comments ******************************************
    //****************************************** comments ******************************************
    //****************************************** comments ******************************************
    //****************************************** comments ******************************************
    //****************************************** comments ******************************************

    public function addComment($parent_id, $user_id, $temp) {
        $sql = "INSERT INTO `post_comments` (`parent_id`, `description`, `img`, `user_id`, `post_id`, `app_version`, `date_added`) ";
        $sql .= "VALUES (:parent_id, :description, :img, :user_id, :post_id, '" . APP_VERSION . "', :date_added)";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':parent_id', $parent_id, PDO::PARAM_INT);
        $stmt->bindParam(':description', $temp['description'], PDO::PARAM_STR);
        $stmt->bindParam(':img', $temp['img'], PDO::PARAM_STR);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->bindParam(':post_id', $temp['post_id'], PDO::PARAM_INT);
        $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);

        $res = $stmt->execute();

        if ($res) {
            // If the comment was successfully added, fetch and return its details
            $commentId = $this->mDb->connect()->lastInsertId();
            return $this->getCommentById($commentId, $user_id);
        } else {
            return false; // Return false if insertion failed
        }
    }

    // Function to get a comment by its ID
    public function getCommentById($comment_id, $user_id) {
        $comment = array();
        $sql = "SELECT * FROM `post_comments` WHERE `id` = :comment_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':comment_id', $comment_id, PDO::PARAM_INT);
        $stmt->execute();
        $comment = $stmt->fetch(PDO::FETCH_ASSOC);

        $sql = "SELECT ua.page_type  FROM `user_auth` ua WHERE `id` = :user_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->execute();

        $res = $stmt->fetch(PDO::FETCH_ASSOC);

        if ($res['page_type'] == 'page') {
            $sql = "SELECT u.user_name, u.img,ua.id,ua.page_type FROM `user_page_acc` u
                    LEFT JOIN `user_auth` ua ON (u.id = ua.page_id)
                    WHERE ua.id = :user_id";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
            $stmt->execute();
            $comment['user_details'] = $stmt->fetch(PDO::FETCH_ASSOC);
        } elseif ($res['page_type'] == 'user') {
            $sql = "SELECT u.user_name, u.img,ua.id,ua.page_type AS page_type FROM `users` u
                    LEFT JOIN `user_auth` ua ON (u.id = ua.user_id)
                    WHERE ua.id = :user_id";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
            $stmt->execute();

            $comment['user_details'] = $stmt->fetch(PDO::FETCH_ASSOC);
        }

        return $comment;
    }

    public function editComment($temp, $user_id) {
        $mo = $this->checkIFCommentISMyComment($temp['comment_id'], $user_id, $temp['post_id']);
        if ($mo) {
            $sql = "UPDATE `post_comments` SET ";
            $sql .= "`description` = :description, ";
            $sql .= "`img` = :img, ";
            $sql .= "`app_version` = '" . APP_VERSION . "', ";
            $sql .= "`date_added` = :date_added ";
            $sql .= "WHERE `id` = :comment_id AND `user_id` = :user_id AND `post_id` = :post_id";

            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':description', $temp['description'], PDO::PARAM_STR);
            $stmt->bindParam(':img', $temp['img'], PDO::PARAM_STR);
            $stmt->bindParam(':comment_id', $temp['comment_id'], PDO::PARAM_INT);
            $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
            $stmt->bindParam(':post_id', $temp['post_id'], PDO::PARAM_INT);
            $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);

            $res = $stmt->execute();

            if ($res) {
                // If the comment was successfully updated, return the updated comment
                return $this->getCommentById($temp['comment_id'], $user_id);
            } else {
                return false; // Return false if the update failed
            }
        }
    }

    public function checkIFCommentISMyComment($comment_id, $id) {
        $sql = "SELECT id FROM post_comments WHERE id = :id AND user_id = :user_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $comment_id, PDO::PARAM_INT);
        $stmt->bindParam(':user_id', $id, PDO::PARAM_INT);
        $stmt->execute();
        return $stmt->fetchColumn();
    }

    public function deleteComment($id, $temp) {
        $myComment = $this->checkIFCommentISMyComment($temp['comment_id'], $id);
        if (!$myComment) {
            $myPost = $this->checkIFPostISMyPost($temp['post_id'], $id);
            $comInMyPost = $this->checkIFCommentOnMyPost($temp['comment_id'], $temp['post_id']);
        }

        if ($myComment || ($myPost && $comInMyPost)) {
            $sql = "DELETE FROM `statistics` WHERE the_id = :comment_id AND is_on = 'comment'";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':comment_id', $id, PDO::PARAM_INT);
            $stmt->execute();

            $this->Delete_Images_InComemnts($temp);
            $deleteChildCommentsSql = "DELETE FROM `post_comments` WHERE `parent_id` = :id";
            $stmt1 = $this->mDb->connect()->prepare($deleteChildCommentsSql);
            $stmt1->bindParam(':id', $temp['comment_id'], PDO::PARAM_INT);
            $stmt1->execute();
            // Delete the main comment
            $deleteCommentSql = "DELETE FROM `post_comments` WHERE `id` = :id";
            $stmt2 = $this->mDb->connect()->prepare($deleteCommentSql);
            $stmt2->bindParam(':id', $temp['comment_id'], PDO::PARAM_INT);
            $res = $stmt2->execute();
            return $res;
        } else {
            return false;
        }
    }

    public function Delete_Images_InComemnts($temp) {
        // Fetch images from the first query
        $sql = "SELECT img FROM `post_comments` WHERE id = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $temp['comment_id'], PDO::PARAM_INT);
        $stmt->execute();
        $image = $stmt->fetchAll(PDO::FETCH_COLUMN);

        $sql = "SELECT img FROM `post_comments` WHERE parent_id = :id";
        $stmt1 = $this->mDb->connect()->prepare($sql);
        $stmt1->bindParam(':id', $temp['comment_id'], PDO::PARAM_INT);
        $stmt1->execute();
        $image1 = $stmt1->fetchAll(PDO::FETCH_COLUMN); // Merge the arrays

        $images = array_merge($image, $image1);
        foreach ($images as $image) {
            $old_img = "../uploads/posts/" . $image;
            if (file_exists($old_img)) {
                @unlink($old_img);
            }
        }
    }

    public function checkIFCommentOnMyPost($id, $post_id) {
        $sql = "SELECT p.user_id
                FROM posts p
                LEFT JOIN post_comments c ON p.id = c.post_id
                WHERE c.id = :id AND c.post_id = :post_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
        $stmt->execute();
        return $stmt->fetchColumn();
    }

    public function getcommentsByPostId($user_id, $parent_id, $aStart = 0, $aLimit = 0, $comment_or_replay = 'comment', $comment_id = '') {
        $blockers = $this->userObj->getAllBlockersByMe($user_id);
        $blocker = implode(',', array_column($blockers, 'block_user_id'));
        $blocker = $blocker ? $blocker : 0;

        $blockeds = $this->userObj->getAllBlockedMe($user_id);
        $blocked = implode(',', array_column($blockeds, 'user_id'));
        $blocked = $blocked ? $blocked : 0;

        $allblockeds = $blocker . ',' . $blocked;

        $sql = "SELECT C.*
        FROM post_comments C
        LEFT JOIN user_auth ua ON ua.id = C.user_id ";

        $sql .= "WHERE C.id > 0  AND C.user_id NOT IN ({$allblockeds}) ";
        $sql .= $comment_or_replay == 'comment' ? "AND (C.post_id = '{$parent_id}' AND C.parent_id = '0') " : "AND (C.parent_id = '{$parent_id}') ";
//        $sql .= "ORDER BY C.id ASC ";

        if ($comment_id != '') {
            $sql .= "ORDER BY CASE WHEN C.id = '{$comment_id}' THEN 1 ELSE 2 END ASC ";
        } else {
            $sql .= "ORDER BY C.id ASC ";
        }

        $sql .= $aLimit ? "LIMIT {$aStart}, {$aLimit}" : '';
//        echo $sql . "<hr>";
        $res = $this->mDb->getAll($sql);

        if ($res) {
            foreach ($res as $key => $comment) {
                $res[$key]['commentIndex'] = $key;
                $res[$key]['likeComment'] = $this->checkPostOrCommentOrReplayByUser_idAndType($comment['id'], $user_id, 'like', 'comment');
                $res[$key]['statistics'] = $this->getNodesStatisticsById($comment['id'], 'comment');
                $res[$key]['replays'] = $this->getcommentsByPostId($user_id, $comment['id'], 0, 10, 'replay');
                $res[$key]['user_details'] = $this->get_user_details($comment['user_id']);
                $res[$key]['description'] = str_replace('<br />', ' <br> ', str_replace(PHP_EOL, '', nl2br($comment['description'])));
            }
        }
        return $res;
    }

    public function get_user_details($user_id) {
        $pageTypeQuery = "SELECT * FROM user_auth WHERE id = :id";
        $pageTypeStmt = $this->mDb->connect()->prepare($pageTypeQuery);
        $pageTypeStmt->bindParam(':id', $user_id, PDO::PARAM_STR);
        $pageTypeStmt->execute();

        $pageType = $pageTypeStmt->fetch(PDO::FETCH_ASSOC);
        if ($pageType['page_type'] === 'user') {
            $sql = "SELECT u.user_name,u.img,a.id,a.page_type
                    FROM users u
                    LEFT JOIN user_auth a ON a.user_id = u.id
                    WHERE u.id = '{$pageType['user_id']}'";
        } elseif ($pageType['page_type'] === 'page') {
            $sql = "SELECT u.user_name , u.img, a.id,a.page_type
                    FROM user_page_acc u
                    JOIN user_auth a ON a.page_id = u.id
                    LEFT JOIN service_langs sl ON u.services_id = sl.service_id AND sl.lang_code =  '" . LANGUAGE . "'
                     WHERE a.id = :id";
        } else {
            return false;
        }
        $query = $this->mDb->connect()->prepare($sql);
        $query->bindParam(':id', $user_id, PDO::PARAM_STR);
        $query->execute();

        $userData = $query->fetch(PDO::FETCH_ASSOC);

        return $userData;
    }

    //****************************************** behind posts ******************************************
    //****************************************** behind posts ******************************************
    //****************************************** behind posts ******************************************
    //****************************************** behind posts ******************************************
    //****************************************** behind posts ******************************************
    public function getNodesStatisticsById($id, $is_on) {
        $res = [];

        // Get like count
        $sql = "SELECT count(s.id) AS like_count FROM statistics s
                LEFT JOIN user_auth ua ON ua.id = s.user_id
                WHERE s.the_id = :id AND s.type = 'like' AND s.is_on = :is_on AND ua.is_deleted = '0' AND ua.active != '0' ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt->bindParam(':is_on', $is_on, PDO::PARAM_STR);
        $stmt->execute();
        $res['like'] = $stmt->fetchColumn();

        // Get comment count based on type
        if ($is_on == 'post' || $is_on == 'video' || $is_on == 'image') {
            $sql = "SELECT count(pc.id) AS comment_count FROM post_comments pc
                    LEFT JOIN user_auth ua ON ua.id = pc.user_id
                    WHERE pc.post_id = :id AND ua.is_deleted = '0' AND ua.active != '0'";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute();
            $res['commentCount'] = $stmt->fetchColumn();
        } else if ($is_on == 'comment') {
            $sql = "SELECT count(pc.id) AS comment_count FROM post_comments pc
                    LEFT JOIN user_auth ua ON ua.id = pc.user_id
                    WHERE pc.parent_id = :id";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute();
            $res['commentCount'] = $stmt->fetchColumn();
        }

        return $res;
    }

    //****************************************** reporting ******************************************
    //****************************************** reporting ******************************************
    //****************************************** reporting ******************************************
    //****************************************** reporting ******************************************
    //****************************************** reporting ******************************************
    public function userAddContentReport($user_id, $temp) {
        $sql = "INSERT INTO `reporting`
                (`user_id`, `reason_id`, `comment`, `type`, `content_id`, `date_added`)
                VALUES
                (:user_id, :reason_id, :comment, :type, :content_id, :date_added)";

        $stmt = $this->mDb->connect()->prepare($sql);

        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->bindParam(':reason_id', $temp['reason_id'], PDO::PARAM_INT);
        $stmt->bindParam(':comment', $temp['comment'], PDO::PARAM_STR);
        $stmt->bindParam(':type', $temp['type'], PDO::PARAM_STR);
        $stmt->bindParam(':content_id', $temp['content_id'], PDO::PARAM_INT);
        $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);

        $stmt->execute();
        return $stmt->rowCount();
    }

    public function getReportingReasons() {
        $sql = "SELECT s.*, sl.name
                FROM reporting_reasons s
                LEFT JOIN reporting_reasons_langs sl
                ON s.id = sl.reason_id AND sl.lang_code = '" . LANGUAGE . "'
                WHERE s.id > 0
                ORDER BY s.sort";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        return $res;
    }

    //******************************************  helper function ******************************************
    //******************************************  helper function ******************************************
    //******************************************  helper function ******************************************
    //******************************************  helper function ******************************************
    //******************************************  helper function ******************************************
    //******************************************  helper function ******************************************

    public function getNodeAttachments($node_id) {
        $sql = "SELECT `name`, `views` FROM `post_images` WHERE post_id = :node_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':node_id', $node_id, PDO::PARAM_INT);
        $stmt->execute();

        return $stmt->fetchAll(PDO::FETCH_ASSOC);
    }

    public function addNodeAttachments($attachments, $node_id, $is_on) {

        if (count($attachments) > 0) {

            foreach ($attachments as $k => $v) {
                if ($v['name']) {

                    $sql = "INSERT INTO ` po_co_medias` SET ";

                    $sql .= " node_id ='{$node_id}' ,  name ='{$v['name']}'  , type = '{$v['type']}'  , is_on = '{$is_on}'   ";

                    $res = $this->mDb->query($sql);
                }
            }
        }
    }

    // public function deleteFromNode($node_id)
    // {
    //     $sql = "DELETE From ` po_co_medias`   ";
    //     $sql .= "where node_id ='{$node_id}'   ";
    //     $this->mDb->query($sql);
    // }

    public function removeNodeAttachments($images, $node_id, $is_on) {

        if (count($images) > 0) {

            foreach ($images as $key => $value) {

                $sql = "DELETE From ` po_co_medias`   ";
                $sql .= "where node_id ='{$node_id}'  AND `name` = '{$value['name']}' AND is_on = '{$is_on}' ";
                $reeee = $this->mDb->query($sql);

                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'posts/' . $value['name'];

                if (file_exists($old_img)) {
                    @unlink($old_img);
                }
                $old_thumbs = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'posts/thumbs/' . $value['name'];

                if (file_exists($old_thumbs)) {
                    @unlink($old_thumbs);
                }
            }
        }
    }



    public function removeSomeData($post_address) {
        if ($post_address) {
            $post_address = explode('،', $post_address);
            $new_post_address = trim($post_address[count($post_address) - 1]) . " - " . trim($post_address[count($post_address) - 2]);
            return $new_post_address;
        }
    }

    public function deleteNotificationPostOrCommentOrReplay($id) {
        $sql = "DELETE  FROM ` notification`   ";
        $sql .= " WHERE  (`url` =  '{$id}' || `sub_url` =  '{$id}') AND (page_type = 'like' || page_type = 'disLike' || page_type = 'likeComment' || page_type = 'disLikeComment' || page_type = 'likeReplay' || page_type = 'disLikeReplay' || page_type = 'addComment'  || page_type = 'addReplay'|| page_type = 'addPost')   ";

        // echo "$sql";
        $this->mDb->query($sql);
    }

    public function deleteNotificationlikeOrDislikPostOrCommentOrReplayByType($user_id, $temp, $url) {
        $sql = "DELETE  FROM ` notification`   ";
        $sql .= " WHERE `send_user_id` =  '{$user_id}' ";
        $sql .= $temp['type'] == 'like' || $temp['type'] == 'disLike' ? " AND `url` =  '{$url}' AND (`page_type` = 'like' || `page_type` = 'disLike' ) " : "";
        $sql .= $temp['type'] == 'likeComment' || $temp['type'] == 'disLikeComment' ? " AND `sub_url` =  '{$url}' AND (`page_type` = 'likeComment' || `page_type` = 'disLikeComment' ) " : "";
        $sql .= $temp['type'] == 'likeReplay' || $temp['type'] == 'disLikeReplay' ? " AND  `sub_url` =  '{$url}' AND (`page_type` = 'likeReplay' || `page_type` = 'disLikeReplay' ) " : "";
        // echo "$sql";
        $sql .= "ORDER BY `date_added` DESC";
        $this->mDb->query($sql);
    }

    public function getServiceNameAndImageById($id) {
        $sql = " SELECT  s.ser_image , sl.ser_name ,sl.ser_description From services s ";
        $sql .= "  LEFT JOIN `service_langs`  sl ON `s`.`id` = `sl`.`service_id` AND  sl.`lang_code` =  'en'  ";
        $sql .= " WHERE s.`id` =  '{$id}'     ";
        $res = $this->mDb->getRow($sql);
        return $res;
    }

    public function getreportMembersForPost($reportId, $reportType, $is_on, $aStart = 0, $aLimit = 0, $id = null) {
        $sql = "SELECT
                CASE
                    WHEN a.page_type = 'page' THEN UPA.img
                    ELSE U.img
                    END AS img,
                a.id,
                CASE
                    WHEN a.page_type = 'page' THEN UPA.user_name
                    ELSE U.user_name
                END AS user_name, S.date_added
            FROM `user_auth` a
            LEFT JOIN `users` U ON (a.user_id = U.id)
            LEFT JOIN `user_page_acc` UPA ON (a.page_id = UPA.id)
            LEFT JOIN `statistics` S ON (a.id = S.user_id)
            WHERE S.type = :reportType AND S.the_id = :reportId";
        $sql .= $is_on ? " AND S.is_on = :is_on" : '';
        if ($id !== null) {
            $sql .= " ORDER BY (a.id = :specific_id) DESC, S.id DESC";
        } else {
            $sql .= " ORDER BY S.id DESC";
        }
        $sql .= $aLimit ? " LIMIT :aStart, :aLimit" : '';

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindValue(':reportType', $reportType, PDO::PARAM_STR);
        $stmt->bindValue(':reportId', $reportId, PDO::PARAM_INT);
        if ($is_on) {
            $stmt->bindValue(':is_on', $is_on, PDO::PARAM_STR);
        }
        if ($id !== null) {
            $stmt->bindValue(':specific_id', $id, PDO::PARAM_INT);
        }
        if ($aLimit) {
            $stmt->bindValue(':aStart', $aStart, PDO::PARAM_INT);
            $stmt->bindValue(':aLimit', $aLimit, PDO::PARAM_INT);
        }
        $stmt->execute();

        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        return $res;
    }

}
