<?php

$UPAObj = new UPA();

class UPA
{

    public $mDb;
    public $mConfig;
    public $lang;
    public $dateTime;

    public function UPA()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->lang = LANGUAGE;
        $this->dateTime = date('Y-m-d H:i:s');
    }
    //****************************************** ADD_EDIT_ACC ******************************************
    //****************************************** ADD_EDIT_ACC ******************************************
    //****************************************** ADD_EDIT_ACC ******************************************
    //****************************************** ADD_EDIT_ACC ******************************************
    //****************************************** ADD_EDIT_ACC ******************************************

    public function addEdit_page_acc($id, $temp, $page_id)
    {
        // Establish a database connection
        $dbConnection = $this->mDb->connect();

        if (!$temp['page_id'] || $temp['page_id'] === null || $temp['page_id'] === '') {
            // Check if the user already has a page
            $existingPageQuery = "SELECT id FROM user_auth WHERE user_id = :user_id AND page_type = 'page' AND is_deleted = '0' AND active != '0'";
            $existingPageStmt = $dbConnection->prepare($existingPageQuery);
            $existingPageStmt->bindParam(':user_id', $id, PDO::PARAM_INT);
            $existingPageStmt->execute();

            $existingPage = $existingPageStmt->fetch(PDO::FETCH_ASSOC);
            if ($existingPage) {
                return false;
            } else {
                // If the user doesn't have a page, proceed with adding a new page
                $sql = "INSERT INTO `user_page_acc` (img, user_name, mobile, description, dial_code, address, services_id) ";
                $sql .= "VALUES (:img, :user_name, :mobile, :descr, :dial_code, :address, :services_id)";

                // Prepare and execute the SQL statement
                $insertPageStmt = $dbConnection->prepare($sql);
                $insertPageStmt->execute([
                    ':img' => $temp['img'],
                    ':user_name' => $temp['user_name'],
                    ':mobile' => $temp['mobile'],
                    ':descr' => $temp['description'],
                    ':dial_code' => $temp['dial_code'],
                    ':address' => $temp['address'],
                    ':services_id' => $temp['services_id'],
                ]);
                // Get the last inserted page_id
                $lastInsertId = $dbConnection->lastInsertId();

                // Add a new entry in user_auth table for the newly added page
                $insertAuthQuery = "INSERT INTO `user_auth` (page_id, page_type, user_id, app_version, lat, lon, date_added,country_symbol) ";
                $insertAuthQuery .= "VALUES (:page_id, 'page', :user_id, :app_version, :lat, :lon, :date_added,:country_symbol)";
                $insertAuthStmt = $dbConnection->prepare($insertAuthQuery);
                $insertAuthStmt->execute([
                    ':page_id' => $lastInsertId,
                    ':user_id' => $id,
                    ':app_version' => APP_VERSION,
                    ':lat' => $temp['lat'],
                    ':lon' => $temp['lon'],
                    ':date_added' => $this->dateTime,
                    ':country_symbol' => $temp['country_symbol'],
                ]);

                $theLastIdOfAuth = $this->mDb->connect()->lastInsertId();

                $sqlFreePosts = "INSERT INTO `post_free` (user_id, img, video, post) ";
                $sqlFreePosts .= "VALUES (:user_id, '0' , '0',  '0')";
                $stmtFreePosts = $this->mDb->connect()->prepare($sqlFreePosts);
                $stmtFreePosts->bindParam(':user_id', $theLastIdOfAuth);
                $stmtFreePosts->execute();

                return $theLastIdOfAuth;
            }
        } else {
            $updateAuthSql = "UPDATE `user_auth` SET 
            updated_at = :pin, lat = :lat, lon = :lon, app_version = :app_version,country_symbol
             = :country_symbol WHERE page_id = :page_id";
            $updateAuthStmt = $dbConnection->prepare($updateAuthSql);

            $updateAuthStmt->execute([
                ':lat' => $temp['lat'],
                ':lon' => $temp['lon'],
                ':app_version' => APP_VERSION,
                ':page_id' => $page_id,
                ':pin' => $this->dateTime,
                ':country_symbol' => $temp['country_symbol'],
            ]);

            if ($temp['last_image']) {

                $old_img = "../uploads/facility/" . $temp['last_image'];
                if (file_exists($old_img)) {
                    @unlink($old_img);
                    $Data['success'] = true;
                } else {
                    $Data['error'] = true;
                }

            }
            $sql = "UPDATE `user_page_acc` SET ";
            $sql .= "img = :img, ";
            $sql .= "user_name = :user_name, ";
            $sql .= "mobile = :mobile, ";
            $sql .= "description = :descr, ";
            $sql .= "services_id = :services_id, ";
            $sql .= "address = :address, ";
            $sql .= "dial_code = :dial_code ";
            $sql .= "WHERE id = :page_id";

            // Prepare and execute the update query for user_page_acc
            $updatePageStmt = $dbConnection->prepare($sql);
            $updatePageStmt->execute([
                ':img' => $temp['img'],
                ':user_name' => $temp['user_name'],
                ':mobile' => $temp['mobile'],
                ':descr' => $temp['description'],
                ':address' => $temp['address'],
                ':services_id' => $temp['services_id'],
                ':dial_code' => $temp['dial_code'],
                ':page_id' => $page_id,
            ]);
            return true;
        }
    }

    public function getpage_id($page_id){
        $sql = "SELECT page_id FROM `user_auth` WHERE `id` = :id AND `page_type` = 'page'";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $page_id, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetch(PDO::FETCH_ASSOC);
        return $res['page_id'];
    }
    public function makeAuthCodeForPages($add_page)
    {
        // Generate a random token
        $randomBytes = random_bytes(32);
        $token = base64_encode($randomBytes);
        $token = preg_replace('/[^a-zA-Z0-9]/', '', $token);

        // Prepare the SQL statement
        $sql = "UPDATE `user_auth` SET `code` = :token WHERE `id` = :add_page AND `page_type` = 'page'";

        $dbConnection = $this->mDb->connect();

        $stmt = $dbConnection->prepare($sql);
        $stmt->execute([
            ':token' => $token,
            ':add_page' => $add_page,
        ]);

    }

    public function add_my_location($id, $lat, $lon)
    {
        $stmt = "UPDATE `user_auth` SET  `lat` = :lat , `lon` = :lon  WHERE `id` = :id";
        $query = $this->mDb->connect()->prepare($stmt);
        $query->bindParam(':lat', $lat, PDO::PARAM_STR);
        $query->bindParam(':lon', $lon, PDO::PARAM_STR);
        $query->bindParam(':id', $id, PDO::PARAM_INT);
        $query->execute();

        return $query->rowCount();
    }
    //****************************************** VIEW ******************************************
    //****************************************** VIEW ******************************************
    //****************************************** VIEW ******************************************
    //****************************************** VIEW ******************************************
    //****************************************** VIEW ******************************************
    public function view_accs($user_id, $id, $page_type)
    {
        if ($page_type === 'user') {
            $sql = "SELECT user_name , img, code, id, page_type
            FROM (
                SELECT u.user_name , u.img, a.code, a.id, a.page_type
                FROM `user_page_acc` u
                LEFT JOIN `user_auth` a ON u.id = a.page_id
                WHERE a.`user_id` = :id AND a.`page_type` = 'page' AND a.is_deleted = '0' AND a.active = '1'
                UNION

                SELECT us.user_name, us.img, a.code, a.id, a.page_type
                FROM `users` us
                LEFT JOIN `user_auth` a ON us.id = a.user_id
                WHERE a.`user_id` = :user_id AND a.`page_type` = 'user' AND  a.is_deleted = '0' AND a.active = '1'
            ) AS combined_data";

            $query = $this->mDb->connect()->prepare($sql);
            $query->bindParam(':id', $id, PDO::PARAM_INT);
            $query->bindParam(':user_id', $user_id, PDO::PARAM_INT);
            $query->execute();

            $res = $query->fetchAll(PDO::FETCH_ASSOC);
            if (!$res) {
                $sql = "SELECT us.user_name, us.img, a.code, a.id, a.page_type
                            FROM `users` us
                            LEFT JOIN `user_auth` a ON us.id = a.user_id
                            WHERE a.`user_id` = :user_id AND a.`page_type` = 'user'";

                $query = $this->mDb->connect()->prepare($sql);
                $query->bindParam(':user_id', $id, PDO::PARAM_INT);
                $query->execute();

                $res = $query->fetchAll(PDO::FETCH_ASSOC);
            }

            return $res;
        } elseif ($page_type === 'page') {
            $sql = "SELECT user_name, img, code, id, page_type,shared_url
            FROM (
                SELECT u.user_name, u.img, a.code, a.id, a.page_type,u.shared_url
                FROM `user_page_acc` u
                LEFT JOIN `user_auth` a ON u.id = a.page_id
                WHERE a.`user_id` = :id AND a.`page_type` = 'page' AND  a.is_deleted = '0' AND a.active = '1'

                UNION

                SELECT us.user_name , us.img, a.code, a.id, a.page_type,us.shared_url
                FROM `users` us
                LEFT JOIN `user_auth` a ON us.id = a.user_id
                WHERE a.`id` = :user_id AND a.`page_type` = 'user' AND  a.is_deleted = '0' AND a.active = '1'
            ) AS combined_data";

            $query = $this->mDb->connect()->prepare($sql);
            $query->bindParam(':id', $user_id, PDO::PARAM_INT);
            $query->bindParam(':user_id', $user_id, PDO::PARAM_INT);
            $query->execute();

            $res = $query->fetchAll(PDO::FETCH_ASSOC);
            return $res;
        }

    }
    public function get_one_acc($temp, $id, $lat, $lon)
    {
        global $postObj;
        global $userObj;
        $sql = "SELECT
                    upa.user_name,
                    upa.img,
                    ua.code,
                    ua.page_type,
                    upa.services_id AS service_id,
                    upa.description,
                    upa.dial_code,
                    upa.mobile,
                    upa.address,
                    ua.lat,
                    ua.lon,
                    sl.ser_name AS service_name,
                    ua.id ";
        $sql .= ($lat !== null && $lon !== null) ? ",(6371 * acos(cos(radians($lat)) * cos(radians(ua.lat)) * cos(radians(ua.lon) - radians($lon)) + sin(radians($lat)) * sin(radians(ua.lat)))) AS distance" : "";
        $sql .= " FROM user_page_acc upa ";

        $sql .= " LEFT JOIN user_auth ua ON upa.id = ua.page_id ";
        $sql .= " LEFT JOIN service_langs sl ON sl.service_id = upa.services_id AND sl.lang_code =  '" . LANGUAGE . "' ";
        $sql .= " WHERE ua.id = :id AND ua.is_deleted = '0' AND ua.active != '0' ";

        $query = $this->mDb->connect()->prepare($sql);
        $query->bindParam(':id', $temp['page_id'], PDO::PARAM_INT);
        $query->execute();
        $res = $query->fetch(PDO::FETCH_ASSOC);
        ///////////////////////////////////////////////
        $pageId = $temp['page_id'];
        $rateInfo = array(
            'rate' => $userObj->calculateAverageRateForPage($pageId),
            'num_of_rates' => $userObj->calculateNumRateForPage($pageId),
            'my_rate' => $this->getmyRate($id, $temp['page_id']),
        );

        // Combine rate information with other statistics
        $res['rate_info'] = $rateInfo;
        //////////////////////////////////////////////////////////////////
        $res['likePage'] = $postObj->checkPostOrCommentOrReplayByUser_idAndType($temp['page_id'], $id, 'like', "page");
        $res['followHim'] = $userObj->checkifFollowingUser($id, $temp['page_id']);
        $res['statistics'] =
            array_merge($postObj->getNodesStatisticsById($temp['page_id'], "page"), [
            'followHimNum' => $userObj->getCountOfFollowers($temp['page_id']),
        ]);
        return $res;
    }
    public function getAllServices($parent_id)
    {
        $sql = "SELECT s.id ,sl.ser_name FROM services s ";
        // $sql .= " LEFT JOIN users` u ON u.id = s.admin_id ";
        $sql .= " LEFT JOIN `service_langs` sl ON s.id = sl.service_id AND sl.lang_code =  '" . LANGUAGE . "'   ";
        // $sql .= " LEFT JOIN `service_langs` sl2 ON s.parent = sl2.service_id ";

        $sql .= " WHERE s.active =  '1' ";
        //  AND sl.lang_code = '{$this->lang}
        $sql .= $parent_id ? " AND s.parent = '{$parent_id}' " : "  AND s.parent = '0' ";

        // echo $sql;

        $res = $this->mDb->getAll($sql);

        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['parentCount'] = $this->getSearchservicesCount($res[$i]['id']);
            }
        }
        return $res;
    }
    public function getSearchservicesCount($parent_id)
    {
        $sql = "SELECT COUNT(s.id)  FROM services s  WHERE s.active =  '1'  ";

        $sql .= $parent_id ? " AND s.parent = '{$parent_id}' " : "  AND s.parent = '0' ";
        return $this->mDb->getOne($sql);
    }
    public function getmyRate($id, $page_id)
    {
        $sql = "SELECT rate FROM `rates` WHERE `page_id` = :page_id AND `user_id` = :user_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':page_id', $page_id, PDO::PARAM_INT);
        $stmt->bindParam(':user_id', $id, PDO::PARAM_INT);
        $stmt->execute();
        $result = $stmt->fetch(PDO::FETCH_ASSOC);
        return $result['rate'] ?? 0;
    }

    //****************************************** DELETE ******************************************
    //****************************************** DELETE ******************************************
    //****************************************** DELETE ******************************************
    //****************************************** DELETE ******************************************
    //****************************************** DELETE ******************************************
    public function delete_acc($id)
    {
        $sql = "UPDATE `user_auth` SET is_deleted = '1' WHERE `id` = :id";
        $query = $this->mDb->connect()->prepare($sql);
        $query->bindParam(':id', $id, PDO::PARAM_INT);
        $query->execute();

        $sql = "DELETE FROM `rates` WHERE page_id = :page_id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':page_id', $id, PDO::PARAM_INT);
        $stmt->execute();

        $sql = "DELETE FROM `followers` WHERE follow_user_id = :page_id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':page_id', $id, PDO::PARAM_INT);
        $stmt->execute();

        $sql = "DELETE FROM `statistics` WHERE user_id = :user_id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $id, PDO::PARAM_INT);
        $stmt->execute();

        $sql = "DELETE FROM `statistics` WHERE the_id = :user_id ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $id, PDO::PARAM_INT);
        $stmt->execute();

        $sql = "DELETE FROM `reporting` WHERE content_id = :user_id AND type = 'user' ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $id, PDO::PARAM_INT);
        $stmt->execute();

        $sql = "SELECT `id`,`post_free`,`type` FROM `posts` WHERE page_acc_id = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $res = $stmt->execute();

        $posts = $stmt->fetchAll(PDO::FETCH_ASSOC);
        foreach ($posts as $post) {
            if ($post['type'] == 'image' || $post['type'] == 'video') {
                $sql = "SELECT id FROM `post_comments` WHERE post_id = :post_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post['id'], PDO::PARAM_INT);
                $stmt->execute();

                $ids = $stmt->fetchAll(PDO::FETCH_ASSOC);
                foreach ($ids as $comment) {
                    $sql = "DELETE FROM `statistics` WHERE the_id = :comment";
                    $stmt = $this->mDb->connect()->prepare($sql);
                    $stmt->bindParam(':comment', $comment['id'], PDO::PARAM_STR);
                    $stmt->execute();
                }

                $sql = "DELETE FROM `statistics` WHERE the_id = :post_id AND is_on = :type";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post, PDO::PARAM_INT);
                $stmt->bindParam(':type', $posts['type'], PDO::PARAM_STR);
                $stmt->execute();

                $sql = "SELECT img FROM `post_comments` WHERE post_id = :post_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post['id'], PDO::PARAM_INT);
                $stmt->execute();

                $images = $stmt->fetchAll(PDO::FETCH_ASSOC);
                foreach ($images as $image) {
                    $old_img = "../uploads/posts/" . $image['name'];
                    if (file_exists($old_img)) {
                        if (@unlink($old_img)) {
                            $Data['success'][] = $image['name'];
                        } else {
                            $Data['error'][] = $image['name'];
                        }
                    }
                }

                $sql = "DELETE FROM `post_comments` WHERE post_id = :post_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post['id'], PDO::PARAM_INT);
                $stmt->execute();

                $sql = "SELECT name FROM `post_images` WHERE post_id = :post_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post['id'], PDO::PARAM_INT);
                $stmt->execute();

                $images = $stmt->fetchAll(PDO::FETCH_ASSOC);
                foreach ($images as $image) {
                    $old_img = "../uploads/posts/" . $image['name'];
                    if (file_exists($old_img)) {
                        if (@unlink($old_img)) {
                            $Data['success'][] = $image['name'];
                        } else {
                            $Data['error'][] = $image['name'];
                        }
                    }
                }
                $sql = "DELETE FROM `post_images` WHERE post_id = :post_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post['id'], PDO::PARAM_INT);
                $stmt->execute();

                $sql = "DELETE FROM `posts` WHERE id = :post_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post['id'], PDO::PARAM_INT);
                $res = $stmt->execute();

            } else {
                $sql = "SELECT id FROM `post_comments` WHERE post_id = :post_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post['id'], PDO::PARAM_INT);
                $stmt->execute();

                $ids = $stmt->fetchAll(PDO::FETCH_ASSOC);
                foreach ($ids as $comment) {
                    $sql = "DELETE FROM `statistics` WHERE the_id = :comment";
                    $stmt = $this->mDb->connect()->prepare($sql);
                    $stmt->bindParam(':comment', $comment['id'], PDO::PARAM_STR);
                    $stmt->execute();

                }

                $sql = "DELETE FROM `statistics` WHERE the_id = :post_id AND is_on = :type";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post, PDO::PARAM_INT);
                $stmt->bindParam(':type', $post['type'], PDO::PARAM_STR);
                $stmt->execute();

                $sql = "SELECT img FROM `post_comments` WHERE post_id = :post_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post['id'], PDO::PARAM_INT);
                $stmt->execute();

                $images = $stmt->fetchAll(PDO::FETCH_ASSOC);
                foreach ($images as $image) {
                    $old_img = "../uploads/posts/" . $image['name'];
                    if (file_exists($old_img)) {
                        if (@unlink($old_img)) {
                            $Data['success'][] = $image['name'];
                        } else {
                            $Data['error'][] = $image['name'];
                        }
                    }
                }
                $sql = "DELETE FROM `post_comments` WHERE post_id = :post_id";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post['id'], PDO::PARAM_INT);
                $stmt->execute();

                $sql = "UPDATE  `posts` SET `is_deleted` = '1' WHERE `id` = :post_id ";
                $stmt = $this->mDb->connect()->prepare($sql);
                $stmt->bindParam(':post_id', $post['id'], PDO::PARAM_INT);
                $res = $stmt->execute();
            }
        }

        return $res;
    }
    //****************************************** Share ******************************************
    //****************************************** Share ******************************************
    //****************************************** Share ******************************************
    //****************************************** Share ******************************************
    //****************************************** Share ******************************************
    public function AddSharedLinkToPostsOrPages($temp){
        if($temp['type'] == 'page'){
         $sql = "UPDATE `user_page_acc` UPA 
                    LEFT JOIN user_auth UA ON  UA.page_id = UPA.id
                    SET UPA.shared_url = :shared_url
                    WHERE UA.id = :id";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':shared_url', $temp['shared_url'], PDO::PARAM_STR);
            $stmt->bindParam(':id', $temp['id'], PDO::PARAM_INT);
            return $stmt->execute();
        }elseif($temp['type'] == 'post'){
            $sql = "UPDATE `posts` SET `shared_url` = :shared_url WHERE `id` = :id";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':shared_url', $temp['shared_url'], PDO::PARAM_STR);
            $stmt->bindParam(':id', $temp['id'], PDO::PARAM_INT);
            return $stmt->execute();
        }
    }
}
