<?php

$users = new users();

class users {

    public $db;
    public $conn;
    public $lang;
    public $dateTime;

    public function __construct() {
        $this->db = new MO();
        $this->conn = $this->db->connect();
        $this->lang = LANGUAGE;
        $this->dateTime = date('Y-m-d H:i:s');
    }

    //****************************************** blocks ******************************************
    //****************************************** blocks ******************************************
    //****************************************** blocks ******************************************
    //****************************************** blocks ******************************************
    //****************************************** blocks ******************************************
    public function getUserByCode($code) {
        $sql = "SELECT * 
                FROM users 
                WHERE code = :code";
        $stmt = $this->conn->prepare($sql);
        $stmt->bindParam(':code', $code);
        $stmt->execute();
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }
    public function checkifBlockingUser($user_id, $block_user_id) {
        $sql = " SELECT  id   FROM `{$this->mPrefix}blockers` ";
        $sql .= " WHERE `user_id` =  '{$user_id}' AND  `block_user_id` =  '{$block_user_id}'    ";
        $res = $this->mDb->getOne($sql) ? true : false;
        return $res;
    }

    public function deleteBlockingUser($user_id, $block_user_id) {
        $sql = "DELETE  FROM `{$this->mPrefix}blockers`   ";
        $sql .= " WHERE `user_id` =  '{$user_id}' AND  `block_user_id` =  '{$block_user_id}'    ";
        return $this->mDb->query($sql);
    }

    public function addBlockingUser($user_id, $block_user_id) {
        $this->deleteFollowingUser($block_user_id, $user_id);
        $sql = "INSERT INTO `blockers` SET ";
        $sql .= "     user_id = '{$user_id}'    ";
        $sql .= " ,   block_user_id = '{$block_user_id}'    ";
        $sql .= " ,  `date_added` = '{$this->dateTime}' ";
        return $this->mDb->query($sql);
    }

    public function getAllBlockersByMe($user_id) {
        $sql = " SELECT  `block_user_id`  FROM `{$this->mPrefix}blockers`  ";
        $sql .= " WHERE  user_id = '{$user_id}' ";
        return $this->mDb->getAll($sql);
    }

    public function getAllBlockedMe($user_id) {
        $sql = " SELECT  `user_id`  FROM `{$this->mPrefix}blockers`  ";
        $sql .= " WHERE  block_user_id = '{$user_id}' ";
        return $this->mDb->getAll($sql);
    }

    //****************************************** follow ******************************************
    //****************************************** follow ******************************************
    //****************************************** follow ******************************************
    //****************************************** follow ******************************************
    //****************************************** follow ******************************************

    public function checkifFollowingUser($user_id, $follow_user_id) {
        $sql = "SELECT id FROM followers WHERE user_id = :user_id AND follow_user_id = :follow_user_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->bindParam(':follow_user_id', $follow_user_id, PDO::PARAM_INT);
        $stmt->execute();

        return $stmt->fetchColumn() ? true : false;
    }

    public function getCountOfFollowers($page_id) {
        $sql = "SELECT COUNT(f.id) FROM followers f
                LEFT JOIN user_auth ua ON ua.id = f.user_id
                WHERE f.follow_user_id = :page_id AND ua.active = '1' AND ua.is_deleted = '0'";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':page_id', $page_id, PDO::PARAM_INT);
        $stmt->execute();
        return $stmt->fetchColumn();
    }

    public function addFollowingUser($user_id, $follow_user_id) {
        $sql = "INSERT INTO followers (user_id, follow_user_id, date_added) VALUES (:user_id, :follow_user_id, :date_added)";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->bindParam(':follow_user_id', $follow_user_id, PDO::PARAM_INT);
        $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);
        $res = $stmt->execute();
        return $res;
    }

    //****************************************** rate ******************************************
    //****************************************** rate ******************************************
    //****************************************** rate ******************************************
    //****************************************** rate ******************************************
    //****************************************** rate ******************************************
    public function checkifRatePage($user_id, $page_id) {
        $sql = "SELECT id FROM rates WHERE user_id = :user_id AND page_id = :page_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->bindParam(':page_id', $page_id, PDO::PARAM_INT);
        $stmt->execute();
        return $stmt->fetchColumn() !== false;
    }

    public function UpdateRatePage($user_id, $page_id, $rate) {
        $sql = "UPDATE rates SET rate = :rate, date_added = :date_added WHERE user_id = :user_id AND page_id = :page_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':rate', $rate, PDO::PARAM_INT);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->bindParam(':page_id', $page_id, PDO::PARAM_INT);
        $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);
        $res = $stmt->execute();

        if ($res) {
            global $userObj;
            $pageId = $page_id;
            $rateInfo = array(
                'rate' => $userObj->calculateAverageRateForPage($pageId),
                'num_of_rates' => $userObj->calculateNumRateForPage($pageId),
                'my_rate' => $this->getmyRate($user_id, $page_id),
            );

            // Combine rate information with other statistics
            $res = array_merge(
                $rateInfo
            );
            return $res;
        }
    }

    public function addRatePage($user_id, $page_id, $rate) {
        global $userObj;
        $sql = "INSERT INTO rates (rate, user_id, page_id, date_added) VALUES (:rate, :user_id, :page_id, :date_added)";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':rate', $rate, PDO::PARAM_INT);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);
        $stmt->bindParam(':page_id', $page_id, PDO::PARAM_INT);
        $res = $stmt->execute();
        $pageId = $page_id;
        $rateInfo = array(
            'rate' => $userObj->calculateAverageRateForPage($pageId),
            'num_of_rates' => $userObj->calculateNumRateForPage($pageId),
            'my_rate' => $this->getmyRate($user_id, $page_id),
        );

        // Combine rate information with other statistics
        $res = array_merge(
            $rateInfo
        );
        return $res;
    }

    public function getmyRate($id, $page_id) {
        $sql = "SELECT rate FROM `rates` WHERE `page_id` = :page_id AND `user_id` = :user_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':page_id', $page_id, PDO::PARAM_INT);
        $stmt->bindParam(':user_id', $id, PDO::PARAM_INT);
        $stmt->execute();
        $result = $stmt->fetch(PDO::FETCH_ASSOC);
        return (string) ($result['rate'] ?? '0');
    }

    public function calculateAverageRateForPage($page_id) {
        $sql = "SELECT AVG(rate) AS average_rate FROM rates WHERE page_id = :page_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':page_id', $page_id, PDO::PARAM_INT);
        $stmt->execute();
        $result = $stmt->fetch(PDO::FETCH_ASSOC);

        // If there are no rates for the page, return '0' as the average
        if ($result && isset($result['average_rate'])) {
            return (string) $result['average_rate']; // Convert to string
        } else {
            return '0'; // Return '0' as string
        }
    }

    public function calculateNumRateForPage($page_id) {
        $sql = "SELECT COUNT(DISTINCT user_id) AS num_rates FROM rates WHERE page_id = :page_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':page_id', $page_id, PDO::PARAM_INT);
        $stmt->execute();
        $result = $stmt->fetch(PDO::FETCH_ASSOC);

        // If there are no rates for the page, return '0'
        if ($result && isset($result['num_rates'])) {
            return (string) $result['num_rates']; // Convert to string
        } else {
            return '0'; // Return '0' as string
        }
    }

    //****************************************** delete ******************************************
    //****************************************** delete ******************************************
    //****************************************** delete ******************************************
    //****************************************** delete ******************************************
    //****************************************** delete ******************************************
    public function changeStatuses($id, $type, $page_id) {

        $sql = "UPDATE `user_auth` SET `active` = :type WHERE `id` = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':type', $type, PDO::PARAM_STR);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);
        $res = $stmt->execute();

        if ($type == '3') {
            $sql1 = "UPDATE `user_auth` SET `active` = '3' WHERE `id` = :id";
            $stmt1 = $this->mDb->connect()->prepare($sql1);
            $stmt1->bindParam(':id', $page_id, PDO::PARAM_INT);
            $stmt1->execute();
            $this->changeDeleteDate($page_id, 0);
        }
        return $res;
    }

    public function changeDeleteDate($id, $type) {
        if ($type == '0') {
            $sql = "UPDATE `user_auth` SET `del_date` = :date WHERE `id` = :id";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->bindParam(':date', $this->dateTime, PDO::PARAM_STR);
            $stmt->execute();
        } elseif ($type == '1') {
            $sql = "UPDATE `user_auth` SET `del_date` = NULL WHERE `id` = :id";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute();
        }
    }

    //****************************************** settings ******************************************
    //****************************************** settings ******************************************
    //****************************************** settings ******************************************
    //****************************************** settings ******************************************
    //****************************************** settings ******************************************
    public function edit_user($temp, $id, $user_auth_id) {
        $sql = "UPDATE `users` SET ";
        $sql .= " `user_name` = :user_name, ";
        $sql .= " `email` = :email, ";
        $sql .= " `dial_code` = :dial_code, ";
        $sql .= " `mobile` = :mobile, ";
        $sql .= " `img` = :img ";
        $sql .= " WHERE `id` = :id";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_name', $temp['full_name'], PDO::PARAM_STR);
        $stmt->bindParam(':email', $temp['email'], PDO::PARAM_STR);
        $stmt->bindParam(':dial_code', $temp['dial_code'], PDO::PARAM_STR);
        $stmt->bindParam(':mobile', $temp['mobile'], PDO::PARAM_STR);
        $stmt->bindParam(':img', $temp['img'], PDO::PARAM_STR);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);

        $success = $stmt->execute();
        if ($success) {

            $sql1 = "UPDATE `user_auth` SET ";
            $sql1 .= "`country_symbol` = :country_symbol ";
            $sql1 .= " WHERE `id` = :user_auth_id";

            $stmt1 = $this->mDb->connect()->prepare($sql1);
            $stmt1->bindParam(':country_symbol', $temp['country_symbol'], PDO::PARAM_STR);
            $stmt1->bindParam(':user_auth_id', $user_auth_id, PDO::PARAM_INT);
            $stmt1->execute();

            global $USAObj;
            $updatedUserData = $USAObj->getUserDataByID($user_auth_id);
            if ($temp['last_image']) {
                $old_img = "../uploads/users/" . $temp['last_image'];
                if (file_exists($old_img)) {
                    @unlink($old_img);
                    $Data['success'] = true;
                } else {
                    $Data['error'] = true;
                }
            }

            // Return the updated user data
            return $updatedUserData;
        } else {
            return false;
        }
    }

    //****************************************** location ******************************************
    //****************************************** location ******************************************
    //****************************************** location ******************************************
    //****************************************** location ******************************************
    //****************************************** location ******************************************
    public function updateLocation($user_id, $lat, $lon) {
        $pageTypeQuery = "SELECT * FROM user_auth WHERE id = :id";
        $pageTypeStmt = $this->mDb->connect()->prepare($pageTypeQuery);
        $pageTypeStmt->bindParam(':id', $user_id, PDO::PARAM_STR);
        $pageTypeStmt->execute();
        $pageType = $pageTypeStmt->fetch(PDO::FETCH_ASSOC);
        if ($pageType['page_type'] === 'user') {
            if ($lat != 0 && $lon != 0) {
                $sql = "UPDATE `user_auth` SET `lat` = '{$lat}',`lon` = '{$lon}' , date_update_location='{$this->dateTime}' ";
                $sql .= "WHERE `id` = '{$user_id}' ";
                $res = $this->mDb->query($sql);
                return $res;
            }
        }
    }
    public function GetAllPageAccs($user_lat, $user_lon, $service_id, $searchKey, $user_id, $start, $limit) {
        $sql = "SELECT
                ua.id
                ,ua.lat
                ,ua.lon
                ,upa.user_name
                ,upa.img";

        if ($user_lat !== null && $user_lon !== null) {
            $sql .= ", (6371 * acos(cos(radians(:user_lat)) * cos(radians(ua.lat)) * cos(radians(ua.lon) - radians(:user_lon)) + sin(radians(:user_lat)) * sin(radians(ua.lat)))) AS distance";
        }

        $sql .= " FROM user_auth ua
              LEFT JOIN user_page_acc upa ON ua.page_id = upa.id
              WHERE ua.page_type = 'page' AND ua.is_deleted = '0' AND ua.active = '1'
              AND upa.services_id = :service_id";

        if ($searchKey) {
            $sql .= " AND upa.user_name LIKE :searchKey";
        }

        $sql .= " ORDER BY " . (($user_lat !== null && $user_lon !== null) ? "distance" : "ua.id");
        $sql .= " LIMIT $start, $limit ";

        $query = $this->mDb->connect()->prepare($sql);

        if ($user_lat !== null && $user_lon !== null) {
            $query->bindParam(':user_lat', $user_lat, PDO::PARAM_STR);
            $query->bindParam(':user_lon', $user_lon, PDO::PARAM_STR);
        }

        $query->bindParam(':service_id', $service_id, PDO::PARAM_STR);

        if ($searchKey) {
            $searchKey = "%$searchKey%";
            $query->bindParam(':searchKey', $searchKey, PDO::PARAM_STR);
        }

        $query->execute();

        $out = [];
        while ($temp = $query->fetch(PDO::FETCH_ASSOC)) {
            $out[] = $temp;
        }

        if ($out) {
            for ($i = 0; $i < count($out); $i++) {
                $out[$i]['followHim'] = $this->checkifFollowingUser($user_id, $out[$i]['page_id']);
            }
        }

        return $out;
    }



    // user function

    public function getUserLevel($id) {
        $sql = "SELECT u.`id` AS 'user_id_in_users', ul.* FROM `users` u";
        $sql .= " LEFT JOIN `user_levels` ul ON ul.id = u.user_level ";
        $sql .= " WHERE u.`id` = :id ";

        //echo $sql; die();
        $query = $this->mDb->connect()->prepare($sql);
        $query->bindParam(':id', $id, PDO::PARAM_STR);
        $query->execute();

        return $query->fetch(PDO::FETCH_ASSOC);
    }

    public function insertAuthCode($aId, $authentication_code) {
        $sql = " UPDATE `user_auth` SET `authentication_code` = '{$authentication_code}'";
        $sql .= " WHERE `id` = '{$aId}'";
        return $this->mDb->query($sql);
    }

    public function checkMobileByParam($value, $id = 0) {
        $sql = "SELECT mobile FROM `{$this->mPrefix}users` ";
        $sql .= "WHERE mobile = :mobile ";
        $sql .= $id ? " AND  `id`!= :id AND user_level is null " : "";

        $query = $this->mDb->connect()->prepare($sql);
        $query->bindParam(':mobile', $value, PDO::PARAM_STR);
        $id ? $query->bindParam(':id', $id, PDO::PARAM_STR) : "";
        $query->execute();

        return $query->fetchColumn(0);
    }

    public function getAuthorizationCodeByUserId($user_id) {
        $sql = "SELECT authentication_code FROM `{$this->mPrefix}users` ";
        $sql .= " WHERE `id` = :id ";

        //echo $sql; die();
        $query = $this->mDb->connect()->prepare($sql);
        $query->bindParam(':id', $user_id, PDO::PARAM_STR);
        $query->execute();
        return $query->fetchColumn(0);
    }

    public function getStatusByUserId($user_id) {
        $sql = "SELECT active FROM `user_auth` ";
        $sql .= " WHERE `id` = :id ";

        $query = $this->mDb->connect()->prepare($sql);
        $query->bindParam(':id', $user_id, PDO::PARAM_STR);
        $query->execute();
        return $query->fetchColumn(0);
    }

    public function getprofileImages() {
        $sql = "SELECT `name` FROM `profile_image`";
        return $this->mDb->getAll($sql);
    }

    public function getForgateDateByParams($mobie_email) {
        $sql = "SELECT `mobile`,`id`,email FROM `users` WHERE (mobile  = :mobie_email ||  email  = :mobie_email ) ";

        $query = $this->mDb->connect()->prepare($sql);
        $query->bindParam(':mobie_email', $mobie_email, PDO::PARAM_STR);
        $query->execute();

        return $query->fetch(PDO::FETCH_ASSOC);
    }

    public function getAllFollowersByMe($user_id) {
        $sql = " SELECT  `follow_user_id`  FROM `{$this->mPrefix}followers`  ";
        $sql .= " WHERE  user_id = '{$user_id}' ";
        return $this->mDb->getAll($sql);
    }

    public function getAllFollowingMe($user_id) {
        $sql = "SELECT `user_id` FROM `followers` WHERE `follow_user_id` = :user_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->execute();
        return $stmt->fetchAll(PDO::FETCH_ASSOC);
    }

    public function getreportMembersForFollowers($reportId, $reportType, $aStart = 0, $aLimit = 0, $id = null) {
        $sql = "SELECT
                    U.img,
                    a.id,
                    U.user_name,
                    F.date_added
                FROM `users` U
                LEFT JOIN `user_auth` a ON U.id = a.user_id
                LEFT JOIN `followers` F ON F.user_id = a.id
                LEFT JOIN `user_page_acc` upa ON a.page_id = upa.id AND F.follow_user_id = a.id";

        if ($reportType == 'followers') {
            $sql .= " WHERE F.follow_user_id = :follow_user_id AND a.active = '1' AND a.is_deleted = '0'";
        }

        if ($id !== null) {
            $sql .= " ORDER BY (a.id = :specific_id) DESC, F.id DESC";
        } else {
            $sql .= " ORDER BY F.id DESC";
        }

        if ($aLimit) {
            $sql .= " LIMIT :aStart, :aLimit";
        }

        $query = $this->mDb->connect()->prepare($sql);
        if ($reportType == 'following') {
            $query->bindParam(':user_id', $reportId, PDO::PARAM_STR);
        } elseif ($reportType == 'followers') {
            $query->bindParam(':follow_user_id', $reportId, PDO::PARAM_STR);
        }

        if ($id !== null) {
            $query->bindParam(':specific_id', $id, PDO::PARAM_INT);
        }

        if ($aLimit) {
            $query->bindValue(':aStart', $aStart, PDO::PARAM_INT);
            $query->bindValue(':aLimit', $aLimit, PDO::PARAM_INT);
        }

        $query->execute();
        $res = $query->fetchAll(PDO::FETCH_ASSOC);

        return $res;
    }

    public function getUserStatistics($id) {
        $sql = "SELECT count(id) FROM `followers`  ";
        $sql .= " WHERE  user_id = :user_id ";

        $query = $this->mDb->connect()->prepare($sql);
        $query->bindParam(':user_id', $id, PDO::PARAM_STR);
        $query->execute();
        $res['followingPeopleByMe'] = $query->fetchColumn(0);

        $sql = "SELECT count(id) FROM `followers` ";
        $sql .= " WHERE  follow_user_id = :follow_user_id ";

        $query = $this->mDb->connect()->prepare($sql);
        $query->bindParam(':follow_user_id', $id, PDO::PARAM_STR);
        $query->execute();
        $res['peopleFollowingMe'] = $query->fetchColumn(0);

        $sql = "SELECT count(id) FROM `posts` ";
        $sql .= " WHERE  user_id = :user_id   ";

        $query = $this->mDb->connect()->prepare($sql);
        $query->bindParam(':user_id', $id, PDO::PARAM_STR);
        $query->execute();
        $res['myPostCount'] = $query->fetchColumn(0);

        $sql = "SELECT posts.user_id, SUM(CASE WHEN statistics.type='like' AND statistics.is_on = 'post' THEN 1 ELSE 0 END) as total_likes   FROM `posts` posts ";
        $sql .= "LEFT JOIN `statistics` statistics ON posts.id = statistics.node_id ";
        $sql .= "WHERE  posts.user_id = :user_id   ";
        $sql .= "GROUP BY posts.user_id";

        $query = $this->mDb->connect()->prepare($sql);
        $query->bindParam(':user_id', $id, PDO::PARAM_STR);
        $query->execute();
        $numNice = $query->fetchColumn(1);
        $res['myPostTotalniceCount'] = $numNice ? $numNice : 0;

        return $res;
    }

    public function getUserserviceName($id) {
        $sql = "SELECT `ser_name` FROM `service_langs` WHERE  lang_code = '{$this->lang}' AND service_id = :service_id ";
        // echo( $sql );die();

        $query = $this->mDb->connect()->prepare($sql);
        $query->bindParam(':service_id', $id, PDO::PARAM_STR);
        $query->execute();
        return $query->fetchColumn(0);
    }

    public function getUnReadNotificationNum_New($aUserId) {
        $sql = "SELECT COUNT(id) AS unread_count FROM notification WHERE receive_user_id = :receive_user_id AND status = '0' ";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':receive_user_id', $aUserId, PDO::PARAM_INT);
        $stmt->execute();

        $result = $stmt->fetch(PDO::FETCH_ASSOC);
        return $result['unread_count'];
    }

    public function deleteFollowingUser($user_id, $follow_user_id) {
        $sql = "DELETE  FROM `{$this->mPrefix}followers`   ";
        $sql .= " WHERE `user_id` =  '{$user_id}' AND  `follow_user_id` =  '{$follow_user_id}'    ";

        //        echo  $sql."<hr>";
        return $this->mDb->query($sql);
    }
}
