<?php
require_once 'init.php';

if ($_GET['action'] == 'AddNewLang' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $right_keys = ['lang', 'name'];
    $keys_err = checkIfKeysRight($Req, $right_keys);
    if ($keys_err) {
        $Data = $Keys_ERR->Keys_ERR($keys_err);
    } elseif (empty($Req['lang'])) {
        $Data = $Langs_ERR->Lang_Empty();
    } elseif (empty($Req['name'])) {
        $Data = $Names_ERR->Name_Empty();
    } elseif (CLIENT['type'] != 'admin') {
        $Data = $Admin_ERR->USER_MUST_ADMIN();
    } elseif ($Lang->checkLang($Req)) {
        $Data = $Langs_ERR->Lang_Exist();
    } else {
        $Data = $Lang->AddNewLang($Req) ? ["success" => true] : $SQL_ERR->AddLangsSqlError();
    }
} elseif ($_GET['action'] == 'GetLangs' && $_SERVER['REQUEST_METHOD'] === 'GET') {
    if (CLIENT['type'] != 'admin') {
        $Data = $Admin_ERR->USER_MUST_ADMIN();
    } else {
        $right_keys = ['name'];
        $keys_err = $Req ? checkIfKeysRight($Req, $right_keys) : null;
        if ($keys_err) {
            $Data = $Keys_ERR->Keys_ERR($keys_err);
        } else {
            $langs = $Lang->GetLangs($Req);
            $Data = $langs ? ["success" => true, "data" => $langs] : $NO_DATA->NO_DATA();
        }
    }
} elseif ($_GET['action'] == 'DeleteLang' && $_SERVER['REQUEST_METHOD'] === 'GET') {
    if (CLIENT['type'] != 'admin') {
        $Data = $Admin_ERR->USER_MUST_ADMIN();
    } else {
        $right_keys = ['id'];
        $keys_err = checkIfKeysRight($Req, $right_keys);
        if ($keys_err) {
            $Data = $Keys_ERR->Keys_ERR($keys_err);
        } else {
            $langs = $Lang->DeleteLang($Req['id']);
            $Data = $langs ? ["success" => true] : $NO_DATA->NO_DATA();
        }
    }
}
echo json_encode($Data);
