<?php

require_once 'init.php';

if ($_GET['action'] == 'checkIfEmailExist' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    if (!isset($user_init['id'])) {
        if (filter_var($Req['email'], FILTER_VALIDATE_EMAIL)) {
            $userInfo = $USAObj->checkIfEmailExist(0, $Req['email']);
            if (!empty($userInfo)) {
                $Data['success'] = true;
                $Data['message'] = 'go_to_login';
            } else {
                if ($Req['email']) {
                    $code = $USAObj->generatePasswordResetToken();
                    if ($code) {
                        $mo_touch = $USAObj->checkIfEmailExist(1, $Req['email']);
                        $stored = $USAObj->storePasswordResetToken($Req['email'], $code);
                        if ($stored) {
                            $emailSubject = "Verification Email";
                            $emailBody = "Hello, you requested to verify your email. Here is your verification code: $code";
                            $fromEmail = $Config['site_email'];

                            if (function_exists('mail')) {
                                $mailed = $mailer->sendEmail($Req['email'], $emailSubject, $emailBody, '<' . $fromEmail . '>', $fromEmail);
                                if ($mailed) {
                                    $Data['success'] = true;
                                    $Data['message'] = 'sended_email';
                                } else {
                                    $Data['success'] = false;
                                    $Data['message'] = 'failed_send_code';
                                }
                            } else {
                                $Data['success'] = false;
                                $Data['message'] = 'failed_send_code';
                            }
                        } else {
                            $Data['success'] = false;
                            $Data['message'] = 'failed_store';
                        }
                    } else {
                        $Data['success'] = false;
                        $Data['message'] = 'failed_gen';
                    }
                } else {
                    $Data['success'] = false;
                    $Data['message'] = 'Email_not_provided';
                }
            }
        } else {
            $Data['error'] = "Invalid_email_format";
        }
    } else {
        $user = $USAObj->checkIfEmailExist(2, $Req['email']);
        if (isset($user['id'])) {
            if ($user['id'] != $user_init['id']) {
                $Data['success'] = false;
                $Data['error'] = 'Email_exists';
                echo json_encode($Data);
                return;
            }
        }
        $code = $USAObj->generatePasswordResetToken();
        if ($code) {
            $mo_touch = $USAObj->checkIfEmailExist(1, $Req['email']);
            $stored = $USAObj->storePasswordResetToken($Req['email'], $code);
            if ($stored) {
                $emailSubject = "Verification Email";
                $emailBody = "Hello, you requested to verify your email. Here is your verification code: $code";
                $fromEmail = $Config['site_email'];

                if (function_exists('mail')) {
                    $mailed = $mailer->sendEmail($Req['email'], $emailSubject, $emailBody, '<' . $fromEmail . '>', $fromEmail);
                    if ($mailed) {
                        $Data['success'] = true;
                        $Data['message'] = 'sended_email';
                    } else {
                        $Data['success'] = false;
                        $Data['message'] = 'failed_send_code';
                    }
                } else {
                    $Data['success'] = false;
                    $Data['message'] = 'failed_send_code';
                }
            } else {
                $Data['success'] = false;
                $Data['message'] = 'failed_store';
            }
        } else {
            $Data['success'] = false;
            $Data['message'] = 'failed_gen';
        }
    }
} elseif ($_GET['action'] == 'login' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    if (empty($Req['mobile'])) {
        $Data = $Mobile_ERR->MobileEmpty();
    } elseif (!is_numeric($Req['mobile'])) {
        $Data = $Mobile_ERR->MobileMustBeNumber();
    } elseif (strlen($Req['password']) < 6) {
        $Data = $PASS_ERR->ShortPassword();
    } elseif ($USAObj->checkIfMobileExist($Req['mobile'])) {
        $signInData = $USAObj->getUserDetailsInfo($Req['mobile'], 'mobile');
        $hash = password_verify($Req['password'], $signInData['password']);
        if ($hash) {
            $USAObj->AddNewLogin($signInData['id']);
            unset($signInData['password']);
            unset($signInData['id']);
            $Data = [
                'success' => true,
                'data' => $signInData
            ];
        } else {
            $Data = $PASS_ERR->WrongPassword();
        }
    } else {
        $Data = $Mobile_ERR->MobileNotExist();
    }
} elseif ($_GET['action'] == 'register' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    if (empty($Req['mobile'])) {
        $Data = $Mobile_ERR->MobileEmpty();
    } elseif (!is_numeric($Req['mobile'])) {
        $Data = $Mobile_ERR->MobileMustBeNumber();
    } elseif (strlen($Req['password']) < 6) {
        $Data = $PASS_ERR->ShortPassword();
    } elseif ($USAObj->checkIfMobileExist($Req['mobile'])) {
        $Data = $Mobile_ERR->MobileExist();
    } elseif (empty($Req['first_name'])) {
        $Data = $Names_ERR->FirstNameEmpty();
    } elseif (empty($Req['last_name'])) {
        $Data = $Names_ERR->LastNameEmpty();
    } elseif (empty($Req['type'])) {
        $Data = $TYPES_ERR->TypeEmpty();
    } elseif (!in_array($Req['type'], ['worker', 'workshop owner', 'user'])) {
        $Data = $TYPES_ERR->TypeNotExist();
    } elseif (
        $Req['type'] == 'worker' &&
        (!isset($Req['worker_data']) ||
            empty($Req['worker_data']) ||
            count($Req['worker_data']) < 4
        )
    ) {
        $Data = $TYPES_ERR->WorkerTypeDataNotCompleted();
    } else {
        $password = password_hash($Req['password'], PASSWORD_DEFAULT);
        $Req['password'] = $password;
        $res = $USAObj->register($Req);
        if ($res) {
            $USAObj->makeAuthCode($res);
            $signInData = $USAObj->getUserDetailsInfo($res, 'register');
            $USAObj->AddNewLogin($signInData['id']);
            if ($Req['type'] == 'worker') {
                $USAObj->InsertWorkerData($Req['worker_data'], $signInData['id']);
            }
            unset($signInData['password']);
            unset($signInData['id']);
            $Data = [
                'success' => true,
                'data' => $signInData
            ];
        } else {
            $Data = $SQL_ERR->RegisterSqlError();
        }
    }
} elseif ($_GET['action'] == 'check_code' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    if (empty($Req['code'])) {
        $Data['error'] = 'Invalid_code';
        $Data['success'] = false;
    } else {
        $userInfo = $USAObj->check_code($Req['email'], $Req['code']);
        if (!$userInfo) {
            $Data['error'] = 'Invalid_code';
            $Data['success'] = false;
        } else {
            $Data['success'] = true;
        }
    }
} elseif ($_GET['action'] == 'forgotPassword' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $userInfo = isset($Req['email']) ? $USAObj->checkIfEmailExist(0, $Req['email']) : $USAObj->checkIfMobileExist($Req['mobile']);

    // Check if the provided email is in a valid format
    if ($userInfo && (!empty($Req['email']) || !empty($Req['mobile']))) {
        if (!empty($Req['email']) && !filter_var($Req['email'], FILTER_VALIDATE_EMAIL)) {
            $Data['success'] = false;
            $Data['error'] = 'Invalid_Email';
        } else {
            if (!empty($Req['email'])) {
                $code = $USAObj->generatePasswordResetToken();
                $stored = $USAObj->storePasswordResetToken($Req['email'] ?? $Req['mobile'], $code);

                if ($stored) {
                    // Send an email with the reset password link
                    $emailSubject = "Reset Password";
                    $emailBody = "Hello you Asked to Change your Password Here Is your Password Reset : $code";
                    $fromEmail = $Config['site_email'];

                    // Check if the mail function exists
                    if (function_exists('mail')) {
                        // Send the email using the mail function
                        $mailed = $mailer->sendEmail($Req['email'], $emailSubject, $emailBody, '<' . $fromEmail . '>', $fromEmail);

                        if ($mailed) {
                            $Data['message'] = 'Password_reset_Pass_sent_to_your_email';
                            $Data['success'] = true;
                        } else {
                            $Data['error'] = 'Failed_to_send_email_Please_try_again_later.';
                            $Data['success'] = false;
                        }
                    } else {
                        $Data['error'] = 'Mail_function_is_not_available_on_this_server.';
                        $Data['success'] = false;
                    }
                } else {
                    $Data['error'] = 'Failed_to_store_password_reset_code.';
                    $Data['success'] = false;
                }
            } else {
                $otp = $USAObj->generatePasswordResetToken();
                $mo_touch = $USAObj->checkIfEmailExist(1, $Req['mobile']);
                $stored = $USAObj->storePasswordResetToken($Req['mobile'], $otp);
                $send_sms = $USAObj->SendSMS($Req, $otp);
                if ($send_sms['Code'] == '4901') {
                    $Data = [
                        "success" => true,
                        "message" => "sended_mobile",
                    ];
                } else {
                    $Data = [
                        "success" => false,
                        "error" => "failed_send"
                    ];
                }
            }
        }
    } else {
        $Data['success'] = false;
        $Data['error'] = 'Email_not_found';
    }
} elseif ($_GET['action'] == 'updatePassword' && $_SERVER['REQUEST_METHOD'] === 'POST') {

    $userInfo = $USAObj->check_code($Req['email'] ?? $Req['mobile'], $Req['code']);
    if (empty($userInfo)) {
        $Data['error'] = 'Invalid_Email_or_Token';
    } elseif (strlen($Req['new_password']) < 6) {
        $Data['error'] = 'Password_Too_Short';
    } else {
        $mo_touch = $USAObj->checkIfEmailExist(1, $Req['mobile']);
        $userInfo = $Req['email'] ? $USAObj->checkIfEmailExist(0, $Req['email']) : $USAObj->checkIfMobileExist($Req['mobile']);
        if (empty($userInfo)) {
            $Req['email'] ? $Data['error'] = 'Email_not_found' : $Data['error'] = 'Mobile_not_found';
        } else {
            $hashedPassword = password_hash($Req['new_password'], PASSWORD_DEFAULT);
            $type = $Req['email'] ? 1 : 2;
            $passwordUpdated = $USAObj->updatePassword($Req['email'] ? $Req['email'] : $Req['mobile'], $hashedPassword, $type);

            if ($passwordUpdated) {
                $Data['message'] = 'Password_updated_successfully';
                $Data['success'] = true;
            } else {
                $Data['error'] = 'Failed_to_update_password_Please_try_again_later.';
                $Data['success'] = false;
            }
        }
    }
} elseif ($_GET['action'] == 'socialLogin' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    if (versionToNumber(APP_VERSION) >= 109) {
        $Data = $USAObj->socialLogin($Req);
    } else {
        $Data = [
            "success" => false,
            "message" => "Invalid Request"
        ];
    }
} elseif ($_GET['action'] == 'SendSMS' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $check = $USAObj->checkIfMobileExist($Req['mobile']);
    if (!empty($check)) {
        $Data = [
            'success' => true,
            'message' => 'go_to_login'
        ];
    } else {
        $otp = $USAObj->generatePasswordResetToken();
        $mo_touch = $USAObj->checkIfEmailExist(1, $Req['mobile']);
        $stored = $USAObj->storePasswordResetToken($Req['mobile'], $otp);
        $send_sms = $USAObj->SendSMS($Req, $otp);
        if ($send_sms['Code'] == '4901') {
            $Data = [
                "success" => true,
                "message" => "sended_mobile",
            ];
        } else {
            $Data = [
                "success" => false,
                "error" => "failed_send"
            ];
        }
    }
}
function versionToNumber(string $version): int {
    $cleanVersion = preg_replace('/[^0-9.]/', '', $version);
    $parts = explode('.', $cleanVersion);
    $number = implode('', $parts);
    return (int) $number;
}

echo json_encode($Data);
