<?php

function checkIfKeysRight($keys, $right_keys) {
    $key_names = array_keys($keys);
    $extra_keys = array_diff($key_names, $right_keys);
    $missing_keys = array_diff($right_keys, $key_names);
    if (!empty($extra_keys) || !empty($missing_keys)) {
        $message = '';
        if (!empty($extra_keys)) {
            $message .= "Extra keys found: " . implode(", ", $extra_keys);
        }
        if (!empty($missing_keys)) {
            $message .= "Missing keys: " . implode(", ", $missing_keys);
        }
        return $message;
    }
}

function checkIfKeysHasEmptyValue($keys, $right_keys) {
    $empty_keys = array_filter($right_keys, fn($key) => isset($keys[$key]) && empty($keys[$key]));
    return !empty($empty_keys) ? "Keys with empty values: " . implode(", ", $empty_keys) : '';
}
